//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include "shiori_dll.h"
#include "nasino.h"
#include "base64.h"


HGLOBAL DicDataTop;
dic_data* DicDataPoint;					/* f[^mۗp|C^̃|C^ */
int DicWordCount;						/* ̑vf */
unsigned int SentenceCount;				// sentence ̐

HGLOBAL DicwordTop;						/* ̓ẽ|C^ */
char* Dicwordpoint;

char script_filename[DataLength];		/* Nasino Script filename */
int ScriptSwitch;						/* XNvgsXCb` */

//char *TagList[TAGLIST_MAX];				/* ${}tagp̃X^bN */
taglist TagList[TAGLIST_MAX];				/* ${}tagp̃X^bN */
unsigned int TagListPoint;						/* ̃|C^ */

dic_readdata Com_word;						/* COMMUNICATẼL[[h */

FILE *fp_log;
int Log = OFF;
char log_filename[DataLength];
int Debug = OFF;

unsigned int Randomseed = 0;
unsigned int sentence_randbuf[SentenceRandbuf];		// sentence̓ꕶ̘Aǂݏo`FbNpOobt@
unsigned int sentence_randbuf_ptr;		// Oobt@|C^

char LogTmp[AnswerLength];

int Script_Log = OFF;
int Reserve_Num;
int Code_Num;

//HGLOBAL DicKey;
//HGLOBAL DicWord;
//char *dicdata_key;
//char *dicdata_word;

extern char *DataPath;										/* ghostpath */
//extern char DataPath[PathLength];						/* ghostpath */

extern char SakuraName[DataLength];
extern char KeroName[DataLength];
extern char FriendName[DataLength];
extern ghost_data ghost_profile;								// GhostɊւf[^
extern ghost_memory communication_memory;						// Communication̋L



//---------------------------------------------------------------------------
//		̏
//---------------------------------------------------------------------------
void dic_ini(void)
{
	DicDataTop = NULL;
	DicwordTop = NULL;

	return;
}

//---------------------------------------------------------------------------
//		̗̈
//---------------------------------------------------------------------------
void dic_unload(void)
{
	if( DicDataTop != NULL ) GlobalFree(DicDataTop);
	if( DicwordTop != NULL ) GlobalFree(DicwordTop);

	DicDataTop = NULL; //NULLȂDllEntryPointunload2xJ
	DicwordTop = NULL;
	
	return;
}

//---------------------------------------------------------------------------
//		ǂݍ
//---------------------------------------------------------------------------
int dic_read(void)
{
	FILE *fp_ini;			/* nasino.ini */
	FILE *fp_dic;
	char data_buffer[DicBufferLength];		/* ̓ǂݏodata */
	char tmp_buffer[DicBufferLength];		/* ̓ǂݏodata */
	char word[DicBufferLength];				/* ؂odata */
	char encode_buffer[DicBufferLength];
	char sym;							/* wordo1 */
	char word_key[DataLength];				/* ؂okeydata */
	char word_key_tmp[DataLength];				/* ؂okeydata */
	char word_data[DataLength];				/* ؂odata */
	char word_datatmp[DataLength];				/* ؂odata */
	
	
	char filename[DataLength];
	char filename_tmp[DataLength];
	unsigned short dicnumber;			/* ԍ */
	int loop;
	int loop2;
	int count1;
	
	int firstline;							// 1sڃtO
	int dictype;							// ̎
	long word_count = 0;					// ̑vf
	long size_count = 0;					// ̗vf̑TCY
	
	int tag_size;
	int data_size;
	int wordkeycount;
	int loop_sakura;
	
	FILE *fp_log;
	
	
	if(get_inifilename(filename) == NG){	/* init@C擾 */
		printf("Can not open inifile.\n");
		return(0);
	}
//	sprintf(filename,"%s%s",DataPath,INI_FILENAME);
//	printf("ini filename : %s\n",filename);

	sprintf(LogTmp,"ini filename : %s\n",filename);
	logwrite(LogTmp);
	logwrite("dic_read start!!\n");
	
	/* ̗̈揉 */
	dic_ini();

	/* 1pX */
	
	loop = ON;
	if((fp_ini=fopen(filename,"rt"))==NULL){
		/* nasino.ini don't open!! */
		printf("nasino.ini don't open!!\n");
		logwrite("nasino.ini don't open!!\n");
		return(FALSE);
	}else{
		do{
			if( fgets(data_buffer,DicBufferLength,fp_ini) == NULL){
//				printf("data_buffer 0: %s\n",data_buffer);
				/* ǂݏoI */
				loop = OFF;
			}else{
//				printf("data_buffer : %s\n",data_buffer);
				/* t@Co */
//				if(get_dicname(filename_tmp,data_buffer) == ON){
				if(read_ini(filename_tmp,data_buffer) == ON){
					sprintf(filename,"%s%s",DataPath,filename_tmp);
					printf("Dictionary Filename : %s\n",filename);
					sprintf(LogTmp,"Dictionary Filename : %s\n",filename);
					logwrite(LogTmp);
					/* Ɋ܂܂ꐔJEg */
					loop2 = ON;
					if((fp_dic=fopen(filename,"rt"))==NULL){
						/* dic-file don't open!! */
						printf("%s don't open!!\n",filename);
//						return(FALSE);
					}else{
						firstline = ON;
						do{
//							if( fgets(data_buffer,DicBufferLength,fp_dic) == NULL){
							if( fgets(encode_buffer,DicBufferLength,fp_dic) == NULL){
//								printf("data0 : %s",data_buffer);
								/* ǂݏoI */
								loop2 = OFF;
							}else{
								strcpy(data_buffer,DecryptString(encode_buffer));			/* Decode */
								// ̎ނ𒲂ׂ
								if(firstline == ON){
									firstline = OFF;
									dictype = check_dictype(data_buffer);
								}
								// ̎ޕʂɏ
								switch(dictype){
								  case DicType_Sakura:
									printf("data1 : %s",data_buffer);
									// PꐔJEg
									// eʃJEg
									strcpy(tmp_buffer,data_buffer);
									getbufword(word,tmp_buffer);
//									printf("word:%s\n",word);
									if(word[0] == '#'){
										strcpy(word_key,word);
									}
									
									wordkeycount = 0;
									while(fgets(encode_buffer,DicBufferLength,fp_dic) != NULL){
									strcpy(data_buffer,DecryptString(encode_buffer));			/* Decode */
										if((data_buffer[0] != '\n') && (strlen(data_buffer) > 1)){
											if((data_buffer[0] != '/') && (data_buffer[1] != '/')){
												strcpy(tmp_buffer,data_buffer);
//												printf("data2 : %s",data_buffer);
//												getbufword(word,tmp_buffer);
												strcpy(word,tmp_buffer);
												word[strlen(word)-1] = '\0';		// b菈u
												
												memcpy(word_datatmp,word,strlen("count"));
												word_datatmp[strlen("count")] = '\0';
												if(strcmp(word_datatmp,"count") == 0){
													printf("key_count:%s\n",word_key);
													printf("count:%s\n",word);
													strcpy(&word[0],&word[strlen("count")]);
													strcpy(word_key_tmp,word_key);
													wordkeycount = atoi(word);
													printf("wordkeycount:%d\n",wordkeycount);
												}else{
													if(word[0] == '#'){
														if((strlen(word_key) > 0) && (strlen(word_data) > 0)){
															tag_size = strlen(word_key) + 1;
															data_size = strlen(word_data) + 1;
															word_count++;
															size_count = size_count + tag_size + data_size;
///															size_count += sizeof(unsigned int) + sizeof(unsigned short);		// P̔ԍAԍ
															printf("key:%s:%d\ndata:%s:%d::%d\n",word_key,tag_size,word_data,data_size,wordkeycount);
															sprintf(LogTmp,"key:%s:%d\ndata:%s:%d::%d;%d\n",word_key,tag_size,word_data,data_size,wordkeycount,size_count);
															logwrite(LogTmp);
														}
														if(wordkeycount == 0){
															strcpy(word_key,word);				// L[̋L
															printf("word_key:%s:%s\n",word_key,tmp_buffer);
														}else{
															strcpy(word_key,word_key_tmp);				// L[̋L
															wordkeycount--;
														}
														strcpy(word_data,"");
													}else{
														if(strlen(word_data) == 0){
															strcat(word_data,word);
														}else{
															strcat(word_data,"\\n");
															strcat(word_data,word);
														}
													}
												}
												
											}
										}
									
									}
									if((strlen(word_key) > 0) && (strlen(word_data) > 0)){
										tag_size = strlen(word_key) + 1;
										data_size = strlen(word_data) + 1;
										word_count++;
										size_count = size_count + tag_size + data_size;
///										size_count += sizeof(unsigned int) + sizeof(unsigned short);		// P̔ԍAԍ
//										printf("key:%s:%d\ndata:%s:%d::%d\n",word_key,tag_size,word_data,data_size,wordkeycount);
//										sprintf(LogTmp,"key:%s:%d\ndata:%s:%d::%d;%d\n",word_key,tag_size,word_data,data_size,wordkeycount,size_count);
//										logwrite(LogTmp);
									}
									printf("sakura_dicread_end0\n");
									sprintf(LogTmp,"size_count:%d\word_count:%d\n",size_count,word_count);
									logwrite(LogTmp);
									
								  	break;
								  case DicType_Nasino:
								  case DicType_Kawari:
									/* vfJEg */
									#ifdef DEBUG_PRINT
									printf("data1 : %s",data_buffer);
									#endif
									strcpy(tmp_buffer,data_buffer);
//									printf("01\n");
									tag_size = dicsize_count(tmp_buffer);
//									printf("02\n");
									size_count += tag_size;
									#ifdef DEBUG_PRINT
									printf("size_count_tmp:%d\n",size_count);
									#endif
									strcpy(tmp_buffer,data_buffer);
//									printf("1\n");
									data_size = dicword_count(tmp_buffer);
//									printf("2\n");
									word_count += data_size;
									#ifdef DEBUG_PRINT
									if(data_size != 0){
										printf("key:%d:data:%d::%s",tag_size,data_size,data_buffer);
										sprintf(LogTmp,"key:%d:data:%d::%s",tag_size,data_size,data_buffer);
										logwrite(LogTmp);
									}
									#endif
								}
							}
						}while(loop2);
					}
					fclose(fp_dic);
					printf("size_count : %d\n",size_count);
					printf("word_count : %d\n",word_count);
				}
			}
		}while(loop);
		
	}
	logwrite("1Pass END\n");
	sprintf(LogTmp,"size_count:%d :: word_count:%d\n",size_count,word_count);
	logwrite(LogTmp);
	
	/* ̈m */

	/* \̗̂̈m */
	DicDataTop=GlobalAlloc(GMEM_FIXED,sizeof(struct dic_data)*word_count);
	if( DicDataTop == NULL ){
		logwrite("dic_read::DicDataTop ERROE!!\n");
		return(FALSE);
	}else{
		DicDataPoint = (struct dic_data *)GlobalLock(DicDataTop);
	}
	/* ̗̎̈m */
	DicwordTop=GlobalAlloc(GMEM_FIXED,size_count);
	if( DicDataTop == NULL ){
		logwrite("dic_read::DicwordTop ERROE!!\n");
		return(FALSE);
	}else{
		Dicwordpoint = (char *)GlobalLock(DicwordTop);
	}
	
	/* t@C|C^擪ɖ߂ */
	fseek( fp_ini, 0, SEEK_SET );
	
	/* 2pX */
	logwrite("2Pass START\n");
	loop = ON;
	word_count = 0;												// wordԍ wordnumber
	dicnumber = 0;												// ԍ
	strcpy(word_key,"");
	strcpy(word_data,"");
	do{
		if( fgets(data_buffer,DicBufferLength,fp_ini) == NULL){
//			printf("data_buffer 0: %s\n",data_buffer);
			/* ǂݏoI */
			loop = OFF;
		}else{
//			printf("data_buffer : %s\n",data_buffer);
			/* t@Co */
//			if(get_dicname(filename_tmp,data_buffer) == ON){
			if(read_ini(filename_tmp,data_buffer) == ON){
				sprintf(filename,"%s%s",DataPath,filename_tmp);
//				printf("Dictionary Filename : %s\n",filename);
				sprintf(LogTmp,"Dictionary Filename : %s\n",filename);
				logwrite(LogTmp);
				/* Ɋ܂܂ꐔJEg */
				loop2 = ON;
				if((fp_dic=fopen(filename,"rt"))==NULL){
					/* dic-file don't open!! */
					printf("%s don't open!!\n",filename);
//					return(FALSE);
				}else{
					firstline = ON;
					do{
//						if( fgets(data_buffer,DicBufferLength,fp_dic) == NULL){
						if( fgets(encode_buffer,DicBufferLength,fp_dic) == NULL){
//							printf("data0 : %s",data_buffer);
							/* ǂݏoI */
							dicnumber++;									// ԍ++
							loop2 = OFF;
						}else{
							strcpy(data_buffer,DecryptString(encode_buffer));			/* Decode */
							// ̎ނ𒲂ׂ
							if(firstline == ON){
								firstline = OFF;
								dictype = check_dictype(data_buffer);
							}
							// ̎ޕʂɏ
							switch(dictype){
								case DicType_Sakura:
									printf("data1 : %s",data_buffer);
									// PꐔJEg
									// eʃJEg
									strcpy(tmp_buffer,data_buffer);
									getbufword(word,tmp_buffer);
//									printf("word:%s\n",word);
									if(word[0] == '#'){
										strcpy(word_key,word);
									}
									
									wordkeycount = 0;
									while(fgets(encode_buffer,DicBufferLength,fp_dic) != NULL){
									strcpy(data_buffer,DecryptString(encode_buffer));			/* Decode */
										if((data_buffer[0] != '\n') && (strlen(data_buffer) > 1)){
											if((data_buffer[0] != '/') && (data_buffer[1] != '/')){
												strcpy(tmp_buffer,data_buffer);
//												printf("data2 : %s",data_buffer);
//												getbufword(word,tmp_buffer);
												strcpy(word,tmp_buffer);
												word[strlen(word)-1] = '\0';		// b菈u
												
												memcpy(word_datatmp,word,strlen("count"));
												word_datatmp[strlen("count")] = '\0';
												if(strcmp(word_datatmp,"count") == 0){
													printf("key_count:%s\n",word_key);
													printf("count:%s\n",word);
													strcpy(&word[0],&word[strlen("count")]);
													strcpy(word_key_tmp,word_key);
													wordkeycount = atoi(word);
													printf("wordkeycount:%d\n",wordkeycount);
												}else{
													if(word[0] == '#'){
														if((strlen(word_key) > 0) && (strlen(word_data) > 0)){
//															printf("key:%s:%d\ndata:%s:%d::%d\n",word_key,tag_size,word_data,data_size,wordkeycount);
														/* number */
															DicDataPoint->wordnumber = (unsigned int)word_count;
															word_count++;
															/* ԍ */
															DicDataPoint->dicnumber = dicnumber;
														/* key̋L */
//															printf("key : %s ::",word_key);
															DicDataPoint->key = Dicwordpoint;
//													printf("k0:%d:%d;%d:",Dicwordpoint,DicDataPoint->key,strlen(word_key));
															strcpy(Dicwordpoint,word_key);
															Dicwordpoint += (strlen(word_key) + 1);
//															Dicwordpoint += (strlen(word_key) + 2);
												
														/* word̋L */
//															printf("word : %s\n",word);
															DicDataPoint->word = Dicwordpoint;
//													printf("w0:%d:%d;%d:\n",Dicwordpoint,DicDataPoint->word,strlen(word_data));
															strcpy(Dicwordpoint,word_data);
															Dicwordpoint += (strlen(word_data) + 1);
//															Dicwordpoint += (strlen(word_data) + 2);
															DicDataPoint++;
//					printf("word_count:%d:%s:%s\n",word_count,word_key,word);
														}
														if(wordkeycount == 0){
															strcpy(word_key,word);				// L[̋L
														}else{
															strcpy(word_key,word_key_tmp);				// L[̋L
															wordkeycount--;
														}
														strcpy(word_data,"");
													}else{
														if(strlen(word_data) == 0){
															strcat(word_data,word);
														}else{
															strcat(word_data,"\\n");
															strcat(word_data,word);
														}
													}
												}
												
											}
										}
									
									}
									if((strlen(word_key) > 0) && (strlen(word_data) > 0)){
										printf("key:%s:%d\ndata:%s:%d::%d\n",word_key,tag_size,word_data,data_size,wordkeycount);
									/* number */
										DicDataPoint->wordnumber = (unsigned int)word_count;
										word_count++;
									/* ԍ */
										DicDataPoint->dicnumber = dicnumber;
									/* key̋L */
//										printf("key : %s ::",word_key);
										DicDataPoint->key = Dicwordpoint;
//										printf("k0:%d:%d;%d:",Dicwordpoint,DicDataPoint->key,strlen(word_key));
										strcpy(Dicwordpoint,word_key);
										Dicwordpoint += (strlen(word_key) + 1);
//										Dicwordpoint += (strlen(word_key) + 2);
									/* word̋L */
//										printf("word : %s\n",word);
										DicDataPoint->word = Dicwordpoint;
//													printf("w0:%d:%d;%d:\n",Dicwordpoint,DicDataPoint->word,strlen(word_data));
										strcpy(Dicwordpoint,word_data);
										Dicwordpoint += (strlen(word_data) + 1);
//										Dicwordpoint += (strlen(word_data) + 2);
										DicDataPoint++;
//					printf("word_count:%d:%s:%s\n",word_count,word_key,word);
									}
									printf("sakura_dicread_end0\n");
									break;
								case DicType_Nasino:
								case DicType_Kawari:
									getkeyword(word_key,data_buffer);				/* keyǂݍ */
									if((word_key[0] == '#') || (word_key[0] == '\0') || (word_key[0] == '\n')){
										/* Rgs */
									}else{
//										printf("data_buffer : %s\n",data_buffer);
										dicread_tagchg(word_key);					// pdl^Oϊ
										
										getmarkword(word,data_buffer);				/* :@ǂݍ */
										if(strcmp(word,":") == 0){
											do{
												getbufword(word,data_buffer);		/* f[^ǂݍ */
												if(strlen(word) != 0){
												/* number */
//													printf("number̋L:");
													DicDataPoint->wordnumber = (unsigned int)word_count;
													word_count++;
												/* ԍ */
//													printf("ԍ̋L:");
													DicDataPoint->dicnumber = dicnumber;
												/* key̋L */
//													printf("key̋L:");
//													printf("key : %s ::",word_key);
													DicDataPoint->key = Dicwordpoint;
//													printf("k0:%d:%d;%d:",Dicwordpoint,DicDataPoint->key,strlen(word_key));
													strcpy(Dicwordpoint,word_key);
//													strcpy(DicDataPoint->key,word_key);
//													printf("k1:");
													Dicwordpoint += (strlen(word_key) + 1);
//													Dicwordpoint += (strlen(word_key) + 2);
//													printf("k2:");
												
												/* word̋L */
//													printf("word̋L");
//													printf("word : %s\n",word);
													DicDataPoint->word = Dicwordpoint;
//													printf("w0:%d:%d;%d:\n",Dicwordpoint,DicDataPoint->word,strlen(word));
													strcpy(Dicwordpoint,word);
													Dicwordpoint += (strlen(word) + 1);
//													Dicwordpoint += (strlen(word) + 2);
													DicDataPoint++;
											
//													sprintf(LogTmp,"key : %s :: word : %s\n",word_key,word);
//													logwrite(LogTmp);
											
//					printf("word_count:%d:%s:%s\n",word_count,word_key,word);
//					sprintf(LogTmp,"word_count:%d:%s:%s\n",word_count,word_key,word);
//					logwrite(LogTmp);
												}
										
											}while(strlen(word) != 0);
										}else{
												/* ȃf[^ */
											sprintf(LogTmp,"C[Kȃf[^ ?%s?\n",word_key);
											logwrite(LogTmp);
										}
									}
							}
							
						}
					}while(loop2);
					sprintf(LogTmp,"word_count:%d\n",word_count);
					logwrite(LogTmp);
				}
				fclose(fp_dic);
				printf("word_count : %d\n",word_count);
			}
		}
	}while(loop);
	fclose(fp_ini);
	
	logwrite("2Pass END\n");
	
	DicWordCount = word_count;
	printf("DicWordCount:%d\n",DicWordCount);
	sprintf(LogTmp,"DicWordCount:%d\n",DicWordCount);
	logwrite(LogTmp);
	

//	#ifdef DEBUG_PRINT
//	DicDataPoint = (struct dic_data *)GlobalLock(DicDataTop);
//	for(count1=0;count1<word_count;count1++){
//		printf("number:%d dicnum:%d :: key:%s :: word:%s\n",(DicDataPoint+count1)->wordnumber,(DicDataPoint+count1)->dicnumber,(DicDataPoint+count1)->key,(DicDataPoint+count1)->word);
//		sprintf(LogTmp,"number:%d dicnum:%d :: key:%s;%d;%d :: word:%s;%d;%d\n",(DicDataPoint+count1)->wordnumber,(DicDataPoint+count1)->dicnumber,(DicDataPoint+count1)->key,(DicDataPoint+count1)->key,strlen((DicDataPoint+count1)->key),(DicDataPoint+count1)->word,(DicDataPoint+count1)->word,strlen((DicDataPoint+count1)->word));
//		logwrite(LogTmp);
//	}
//	printf("\n");
//	logwrite("\n");
//	GlobalUnlock(DicDataTop);
//	#endif
	
	strcpy(Com_word.word,"");				/* gƂɂ͕ύXKvBp֐pӂׂ */
	strcpy(Com_word.key,"");

	
	logwrite("NORMAL return!!\n");
	return(0);
}


//---------------------------------------------------------------------------
//		̃^Cv`FbN
//		buffer󂵂Ă͂ȂB
//---------------------------------------------------------------------------
int check_dictype(char *buffer)
{
	char tmp_buffer[DicBufferLength];		/* ̓ǂݏodata */
	char word[DicBufferLength];				/* ؂odata */
	int ret;

	strcpy(tmp_buffer,buffer);
	getbufword(word,tmp_buffer);
	str_toupper(tmp_buffer,word);
	printf("check_dictype:%s\n",tmp_buffer);
	if(strcmp(tmp_buffer,"[NASINO]") == 0){
//		printf("[nasino]\n");
		logwrite("[nasino]\n");
		ret = DicType_Nasino;
	}else if(strcmp(word,"[SAKURA]") == 0){
//		printf("[SAKURA]\n");
		logwrite("[SAKURA]\n");
		ret = DicType_Sakura;
	}else{
//		printf("[Kawari]\n");
		logwrite("[Kawari]\n");
		ret = DicType_Kawari;
	}
	
	return(ret);
}


//---------------------------------------------------------------------------
//		Word̃`FbN
//---------------------------------------------------------------------------
int check_dicword(char *word)
{
	int len;
	int ret = OK;
	
	len = strlen(word);
	if( (word[0] == START_TAG1) && (word[1] == START_TAG2)
	 && (word[len-1] != END_TAG) ){
	 	strcat(word,END_TAG2);
	 	ret = NG;
	 }

	return(ret);
}

//---------------------------------------------------------------------------
//		init@C̖O擾
//---------------------------------------------------------------------------
int get_inifilename(char *filename)
{
	FILE *fp_ini;
	int ret;
	
	sprintf(filename,"%s%s",DataPath,INI_FILENAME1);
	printf("ini filename : %s\n",filename);
	if((fp_ini=fopen(filename,"rt"))!=NULL){
		ret = OK;
		fclose(fp_ini);
	}else{
		sprintf(filename,"%s%s",DataPath,INI_FILENAME2);
//		printf("ini filename : %s\n",filename);
		if((fp_ini=fopen(filename,"rt"))!=NULL){
			ret = OK;
			fclose(fp_ini);
		}else{
			strcpy(filename,"");
			ret = NG;
		}
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		̂Ps̗vfJEg
//---------------------------------------------------------------------------
long dicword_count(char* data_buffer)
{
	long word_count = 0;
	char word[DicBufferLength];				/* ؂odata */
	
//	printf("dicword_count_data : %s\n",data_buffer);
	getkeyword(word,data_buffer);
//	if(word[0] == '#'){
	if((word[0] == '#') || (word[0] == '\0')){
		/* Rgs */
	}else{
//		printf("dicword_count_data : %s\n",data_buffer);
		getmarkword(word,data_buffer);
		if(strcmp(word,":") == 0){
			do{
				getbufword(word,data_buffer);
				if(strlen(word) != 0){
//					printf("dicword_count_word : %s\n",word);
					word_count++;
				}
			}while(strlen(word) != 0);
		}
	}

	return(word_count);
}

//---------------------------------------------------------------------------
//		̂Ps̃TCYJEg
//---------------------------------------------------------------------------
long dicsize_count(char* data_buffer)
{
	long dicsize = 0;
	char key[DicBufferLength];				/* ؂odata */
	char word[DicBufferLength];				/* ؂odata */
	char word_tmp[DicBufferLength];				/* ؂odata */
	int tag_size;
	
	getkeyword(key,data_buffer);
//	if(key[0] == '#'){
	if((key[0] == '#') || (key[0] == '\0')){
		/* Rgs */
	}else{
		
		dicread_tagchg(key);					// p^O̕ϊ
		
//		printf("data : %s\n",data_buffer);
		tag_size = strlen(key) + 1;
		getmarkword(word,data_buffer);
		if(strcmp(word,":") == 0){
			do{
				getbufword(word,data_buffer);
				if(strlen(word) != 0){
//					printf("word : %s : %s",key,word);
					dicsize += tag_size + strlen(word) + 1;
///					dicsize += sizeof(unsigned int) + sizeof(unsigned short);		// P̔ԍAԍ
//					printf(" : %d\n",dicsize);
				}
			}while(strlen(word) != 0);
		}
	}
	

	return(dicsize);
}

//---------------------------------------------------------------------------
//		p^O̕ϊ
//---------------------------------------------------------------------------
void dicread_tagchg(char* key)
{
	char word_tmp[DicBufferLength];				/* ؂odata */
	
	if((key[0] == '[') && (key[strlen(key)-1] == ']')){		// ؘatag
//		sprintf(word_tmp,"%s%s",KAWARI_TAG,key);
		sprintf(word_tmp,"nasino sentence %s",key);
		strcpy(key,word_tmp);
//		printf("key :%s:\n",key);
	}
	
	return;
}

//---------------------------------------------------------------------------
//		nasino.ini ̓ǂ݂
//---------------------------------------------------------------------------
int read_ini(char* filename,char* data_buffer)
{
	char word[DataLength];				/* ؂odata */
	char tmp_word[DataLength];			/* ؂odata */
	char tmp_buffer[DataLength];		/* ̓ǂݏodata */
	int ret;
	
	char pattern[20][20]={"DICT","RANDOMSEED","LOG","DEBUG","TALK_INTERVAL","SCRIPT_LOG","SCRIPT"""};
	int pattern_n;
	int ptr;
	
	str_toupper(tmp_buffer,data_buffer);			// filename܂ő啶ɂ̂͂ƃ}Y񂶂ˁ[́H
//	getbufword(word,tmp_buffer);
	getkeyword(word,tmp_buffer);				/* keyǂݍ */
	
	pattern_n = 0;
	do{											/* p^[}b`O */
		ptr=strcmp(word,pattern[pattern_n]);
//		printf("word:%s:%s:%d\n",word,pattern[pattern_n],pattern_n);
		pattern_n++;
	}while(ptr!=0 && strcmp(pattern[pattern_n-1],"")!=0);
	
//	getbufword(word,tmp_buffer);
	getmarkword(word,tmp_buffer);
//	printf("word0 %s\n",word);
	if(strcmp(word,":") == 0){
		getbufword(word,tmp_buffer);
	}else if(word[0] == ':'){
		strcpy(&word[0],&word[1]);
	}
	
	switch(pattern_n){
		case Com_DICT:							/* dict */
			if(strlen(word) == 0){
				strcpy(filename,NULL);
				ret = OFF;
			}else{
				strcpy(filename,word);
				printf("dic_filename:%s\n",filename);
				ret = ON;
			}
			break;
		case Com_RANDOMSEED:					/* randomseed */
			printf("RANDOMSEED\n");
			Randomseed = atoi(word);
			printf("RANDOMSEED:%d\n",Randomseed);
			break;
		case Com_LOG:							/* log */
			printf("LOG\n");
			Log = check_onoff(word);
//			if(Log == ON){
//				sprintf(log_filename,"%s%s",DataPath,TESTLOG_FILENAME);
//				fp_log = fopen(log_filename,"at");
//			}
			sprintf(LogTmp,"Log : %d\n",Log);
			logwrite(LogTmp);
			break;
		case Com_DEBUG:							/* debug */
			printf("DEBUG\n");
			Debug = check_onoff(word);
			sprintf(LogTmp,"Debug : %d\n",Debug);
			logwrite(LogTmp);
			break;
		case Com_TALK_INTERVAL:					// Talk_interval
			printf("TALK_INTERVAL\n");
			ghost_profile.ghosttalkinterval = atoi(word);
			sprintf(LogTmp,"Talk_interval : %d\n",ghost_profile.ghosttalkinterval);
			logwrite(LogTmp);
			break;
		case Com_SCRIPT_LOG:							/* log */
			printf("SCRIPT_LOG\n");
			Script_Log = check_onoff(word);
			sprintf(LogTmp,"SCRIPT_LOG : %d\n",Log);
			logwrite(LogTmp);
			break;
		case Com_SCRIPT:								/* sclipt filename */
			printf("SCRIPT\n");
			if(strlen(word) == 0){
				strcpy(script_filename,NULL);
				ScriptSwitch = OFF;
				ret = OFF;
			}else{
				strcpy(script_filename,word);
				printf("script_filename:%s\n",script_filename);
				ScriptSwitch = ON;
			}
			break;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		t@C؂o
//---------------------------------------------------------------------------
int get_dicname(char* filename,char* data_buffer)
{
	char word[DataLength];				/* ؂odata */
	int ret;

	getbufword(word,data_buffer);
	if(strcmp(word,"dict") == 0){
		getbufword(word,data_buffer);
		if(strcmp(word,":") == 0){
			getbufword(filename,data_buffer);	//	t@C
		}
	}else{
		strcpy(filename,"");
	}
	
	if(strlen(filename) == 0){
		ret = OFF;
	}else{
		ret = ON;
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		Po
//---------------------------------------------------------------------------
int get_dicword(struct dic_readdata *dic_data,long num)
{
	int ret;
	FILE *fp_log;
	int tmp;
	int count1;

//	printf("num:%d:%d\n",DicWordCount,num);
	if(num < DicWordCount){
		DicDataPoint = (struct dic_data *)GlobalLock(DicDataTop);
		if(DicDataPoint != NULL){
//			printf("get_dicword\n");
			dic_data->wordnumber = (DicDataPoint + num)->wordnumber;
			dic_data->dicnumber = (DicDataPoint + num)->dicnumber;
			strcpy(dic_data->key,(DicDataPoint + num)->key);
			strcpy(dic_data->word,(DicDataPoint + num)->word);
//			printf("get_dicword2\n");
		}else{
			printf("DicDataPoint = NULL!\n");
		}
		GlobalUnlock(DicDataTop);

		ret = ON;
	}else{
		ret = OFF;
	}
	
//	printf("get_dicword\n");
	return(ret);
}

//---------------------------------------------------------------------------
//		v̂쐬
//---------------------------------------------------------------------------
int n_getword(char *answer,char *keycode,int nest)
{
//	char answer_tmp[AnswerLength];
	char *answer_tmp;

	printf("n_getword:keycode:%s:\n",keycode);

//	if(Debug == ON){
//		sprintf(LogTmp,"\tn_getword : %s\n",keycode);
//		logwrite(LogTmp);
//	}

	answer_tmp = NULL;

	if(tagchange(answer,keycode,nest) == NG){
		if((answer_tmp = (char*)malloc(sizeof(char) * AnswerLength))==NULL){
			
		}else{
			get_tagword(answer_tmp,keycode);
			printf("answer_tmp:%s\n",answer_tmp);
			make_sentence(answer,answer_tmp,nest);
		}
	}
	free(answer_tmp);

	return(0);
}

//---------------------------------------------------------------------------
//		߂Gg̒PoB
//		sentenceɂẮAOobt@QƂA̓eA
//		ԂȂ悤ɂB
//
//		char *answer		OUT		oP
//		char *keycode		IN		oP̃Gg
//---------------------------------------------------------------------------
int get_tagword(char *answer,char *keycode)
{
	dic_readdata dicreaddata;
	int *tag_table;							// ɂΏۂ̃e[u
//	int tag_table[255];							// ɂΏۂ̃e[u
	
	int rand_tmp;
	int count1;
	unsigned int loop;
	int word_count;
	char answer_tmp[AnswerLength];
	
//	static unsigned int sentence_randbuf[10];	// sentence̓ꕶ̘Aǂݏo`FbNpOobt@
//	static unsigned int sentence_randbuf_ptr;	// Oobt@|C^
	
	
//	printf("get_tagword:%s:\n",keycode);
//	logwrite("get_tagword:");
	
	if(DicWordCount == 0){
		strcpy(answer,"");					/* Ȃ */
	}else if((strcmp(Com_word.word,"") != 0) && (strcmp(Com_word.key,keycode) == 0)){				/* COMMUNICATE荞 */
//		printf("0:");
//		sprintf(LogTmp,"keycode :%s::%s::%s:\n",keycode,Com_word.key,Com_word.word);
//		logwrite(LogTmp);
		
		strcpy(answer,Com_word.word);
		
	}else{
		if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
//			// malloc error.
			printf("malloc error!!\n");
			logwrite("get_tagword malloc error!!\n");
		}else{
			word_count = tagwordcount(keycode,tag_table);				// ^OɊ܂܂P̐璲ׂ

			if(word_count != 0){
				if(word_count == 1){
					rand_tmp = 0;
				}else{
//					rand_tmp = rand() % (word_count-1);
					if((strcmp(keycode,SENTENCE_TAG) == 0) && (word_count > SentenceRandbuf) ){
					// sentence Gg@Oobt@QƂđI
//						logwrite("/// sentence Gg ///\n");
						do{
							rand_tmp = rand() % (word_count);
							count1 = 0;
							loop = OFF;
							for(count1=0;count1<SentenceRandbuf;count1++){
//								printf("sentence : %d :: %d \n",sentence_randbuf[count1],rand_tmp);
//								sprintf(LogTmp,"sentence : %d :: %d \n",sentence_randbuf[count1],rand_tmp);
//								logwrite(LogTmp);
								if(sentence_randbuf[count1] == rand_tmp){
									loop = ON;
								}
							}
							if(loop == OFF){
								sentence_randbuf[sentence_randbuf_ptr] = rand_tmp;
								sentence_randbuf_ptr++;
								if(sentence_randbuf_ptr == SentenceRandbuf){
									sentence_randbuf_ptr = 0;
								}
							}
						}while(loop);
					}else{
					// ̑̃Gg
						rand_tmp = rand() % (word_count);
					}
				}
				
//				printf("word_count : %d :: %d :: %s\n",word_count,rand_tmp,keycode);
//				sprintf(LogTmp,"word_count : %d :: %d :: %s\n",word_count,rand_tmp,keycode);
//				logwrite(LogTmp);
		
				get_dicword(&dicreaddata,tag_table[rand_tmp]);
				strcpy(answer_tmp,dicreaddata.word);
			}else{
//				printf("ȃR[hȂ\n");
//				logwrite("ȃR[hȂ\n");
//				strcpy(answer,"ȃR[hȂ");
//				printf("ȃR[hȂ : %d : %s\n",nest,answer);
				strcpy(answer_tmp,"${compatible-m}");					/* mȂR[h͈ʖƂ */
			}
		
			strcpy(answer,answer_tmp);
//			sprintf(LogTmp,"answer! : %s\n",answer);
//			logwrite(LogTmp);
			free(tag_table);
		}
	}

	return(word_count);
}

//---------------------------------------------------------------------------
//		ɗ^ꂽ^Ǒꂪ邩ׂ
//---------------------------------------------------------------------------
int tagwordcount(char* tag,int *tag_table)
{
	int word_count;
	int count1;
	char word_tmp[DicBufferLength];				/* ؂odata */
	char tag_tmp[DicBufferLength];				/* tag */
	
	dic_readdata dicreaddata;
	
	word_count = 0;
//	printf("tagwordcount:%s\n",tag);
	if((strstr(tag,NASINO_TAG) != NULL) || (strstr(tag,KAWARI_TAG) != NULL)){		// Ɋ܂܂Ał͂ȂA擪ɂ邩`FbNׂ
	// ^O || ؘa^O
		for(count1=0;count1<DicWordCount;count1++){
			get_dicword(&dicreaddata,count1);
			if(strstr(dicreaddata.key,tag) != NULL){
				printf("keycode1 : %s :: %s :: %s\n",tag_tmp,dicreaddata.key,dicreaddata.word);
//				sprintf(LogTmp,"Mach! keycode : %s :: %s :: %s\n",keycode,dicreaddata.key,dicreaddata.word);
//				logwrite(LogTmp);
				tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
				word_count++;
			}
		}
	}else{
		for(count1=0;count1<DicWordCount;count1++){
			get_dicword(&dicreaddata,count1);
//			printf("keycode0 : %s :: %s\n",tag,dicreaddata.key);
//			sprintf(LogTmp,"keycode : %s :: %s\n",keycode,dicreaddata.key);
//			logwrite(LogTmp);
			if(strcmp(dicreaddata.key,tag) == 0){
				printf("keycode1 : %s :: %s :: %s\n",tag,dicreaddata.key,dicreaddata.word);
//				sprintf(LogTmp,"Mach! keycode : %s :: %s :: %s\n",keycode,dicreaddata.key,dicreaddata.word);
//				logwrite(LogTmp);
				tag_table[word_count] = dicreaddata.wordnumber;		// ̔ԍe[uɓo^
				word_count++;
			}
		}
	}
	tag_table[word_count] = DicWordCount + 1;		// ^[~l[^o^
	printf("word_count:%d\n",word_count);
	

	return(word_count);
}


//---------------------------------------------------------------------------
//		^ꂽ͂̃^OB
//---------------------------------------------------------------------------
void make_sentence(char* answer,char* buffer,int nest)
{
	
	int count1;
	int loop;
	int tagf;
	int symbol_len;
	char sym[3];
	char *tag_tmp = NULL;
	struct s20_data *commdata;			// SHIORI/2.0͌	NISp
	struct s20_data *answerdata;
//	struct s20_data commdata;			// SHIORI/2.0͌	NISp
//	struct s20_data answerdata;

	printf("*** make_sentence ***\n");
	logwrite("*** make_sentence ***\n");
//	sprintf(LogTmp,"nest%d:%s\n",nest,buffer);
//	logwrite(LogTmp);
	
//	s20_data_clear(&commdata);
//	s20_data_clear(&answerdata);
	
	if((tag_tmp = (char*)malloc(AnswerLength))==NULL){
		printf("malloc error.\n");
		strcpy(answer,"malloc error.");
	}else{
		count1 = 0;
		loop = ON;
		tagf = OFF;

//		sprintf(LogTmp,"nest%d:%s\n",nest,buffer);
//		logwrite(LogTmp);
//		printf("buffer:%s\n",buffer);
		
		do{
			symbol_len = chksymsj(sym,buffer);
			if(symbol_len == 1){
				tag_tmp[0] = '\0';
				if((buffer[0] == START_TAG1) && (buffer[1] == START_TAG2)){
				// ${}
//					logwrite("\t*** ${} ***\n");
					tagf = '}';
					make_tagcode(tag_tmp,buffer,nest);
//					printf("A tag_tmp:%s\n",tag_tmp);
//					printf("answer len:%d tag_tmp len:%d\n",strlen(&answer[count1]),strlen(tag_tmp));
					strcpy(&answer[count1],tag_tmp);
					count1 += strlen(tag_tmp);
				}else if(buffer[0] == END_TAG){
				// ${}I
//					logwrite("\t*** ${}I ***\n");
					if(tagf == '}'){
//						printf("${}\n");
						strcpy(&buffer[0],&buffer[1]);
						tagf = OFF;
//						printf("answer_tmp:%s:\n",buffer);
					}else{
						// ʏ̔pƂďB
//						printf("normal:%s:\n",sym);
						strcpy(&answer[count1],sym);
						strcpy(&buffer[0],&buffer[1]);
//						printf("%s\n",answer);
						count1 ++;
						loop = OFF;
					}
				}else if((buffer[0] == START_TAG1) && (buffer[1] == KIS_START_TAG1)){	// $( Ŏn܂Ă
				// $()
//					logwrite("\t*** $() ***\n");
					
					if(( (commdata = (s20_data*)malloc(sizeof(s20_data)))==NULL) || ( (answerdata = (s20_data*)malloc(sizeof(s20_data)))==NULL) ){
						strcpy(&answer[count1],"umake_sentencevŃmۂł܂łB");
						printf("malloc error.\n");
					}else{
						s20_data_clear(commdata);
						s20_data_clear(answerdata);
						tagf = ')';
//						make_kiscode(tag_tmp,buffer,nest,commdata);
						make_kiscode(answerdata,buffer,nest,commdata);
						shiori_answer_encode(tag_tmp,*answerdata,commdata->code);
						printf("make_kiscode answer:%s\n",tag_tmp);
						strcpy(&answer[count1],answerdata->sentence);
						count1 += strlen(answerdata->sentence);
					}
					free(commdata);
					free(answerdata);
					commdata = NULL;
					answerdata = NULL;
				}else if(buffer[0] == KIS_END_TAG){
				// $()I
//					logwrite("\t*** $()I ***\n");
					if(tagf == ')'){
//						printf("$()\n");
						strcpy(&buffer[0],&buffer[1]);
						tagf = OFF;
//						printf("answer_tmp:%s:\n",buffer);
					}else{
						// ʏ̔pƂďB
//						printf("normal:%s:\n",sym);
						strcpy(&answer[count1],sym);
						strcpy(&buffer[0],&buffer[1]);
//						printf("%s\n",answer);
						count1 ++;
						loop = OFF;
					}
				}else{
				// tagłȂʏ피p̏
//					logwrite("\t*** tagłȂʏ피p̏ ***\n");
//					printf("normal:%s:\n",sym);
					strcpy(&answer[count1],sym);
					strcpy(&buffer[0],&buffer[1]);
//					printf("%s\n",answer);
					count1 ++;
				}

			}else if(symbol_len == 2){						// 2bytȅ
//				logwrite("\t*** 2bytȅ ***\n");
				if((count1+2) < AnswerLength){
//					printf("2bytenormal:%s:\n",sym);
					strcpy(&answer[count1],sym);
					strcpy(&buffer[0],&buffer[2]);
					count1 += 2;
				}else{
//					printf("answer_tmp OVERFLOW!\n");
					loop = OFF;
				}
			}
			
		}while((strlen(buffer)>0) && (loop == ON));
		answer[count1] = '\0';
		
		taglist_free(nest);									/* TAG̋L̈ */
	}
	free(tag_tmp);
#ifdef DEBUG_PRINT
	printf("return:%s\n",answer);
#endif
//	sprintf(LogTmp,"answer:%s\n",answer);
//	logwrite(LogTmp);

	return;
}

//		struct s20_data *commdata.buffer		IN		̓ZeX
//		struct s20_data *commdata.code			OUT		fR[hpR[h
//		struct s20_data *answerdata				OUT		o
void make_sentence2(struct s20_data *answerdata,struct s20_data *commdata,int nest)
{
	
	int count1;
	int loop;
	int tagf;
	int symbol_len;
	char sym[3];
	char *tag_tmp = NULL;
	struct s20_data *niscode_ret;

	logwrite("*** make_sentence2 ***\n");
//	printf("*** make_sentence2 ***\n");

	niscode_ret = NULL;
	
	if((tag_tmp = (char*)malloc(AnswerLength))==NULL){
		strcpy(answerdata->sentence,"malloc error.");
	}else{
		count1 = 0;
		loop = ON;
		tagf = OFF;

//		sprintf(LogTmp,"nest%d:%s\n",nest,commdata->buffer);
//		logwrite(LogTmp);
//		printf("buffer:%s\n",buffer);
		
		do{
			symbol_len = chksymsj(sym,commdata->buffer);
			if(symbol_len == 1){
				tag_tmp[0] = '\0';
				if((commdata->buffer[0] == START_TAG1) && (commdata->buffer[1] == START_TAG2)){
				// ${}
					tagf = '}';
					make_tagcode(tag_tmp,commdata->buffer,nest);
//					printf("A tag_tmp:%s\n",tag_tmp);
//					printf("answer len:%d tag_tmp len:%d\n",strlen(&answer[count1]),strlen(tag_tmp));
					strcpy(&answerdata->sentence[count1],tag_tmp);
					count1 += strlen(tag_tmp);
				}else if(commdata->buffer[0] == END_TAG){
				// ${}I
					if(tagf == '}'){
//						printf("${}\n");
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
						tagf = OFF;
//						printf("answer_tmp:%s:\n",buffer);
					}else{
						// ʏ̔pƂďB
//						printf("normal:%s:\n",sym);
						strcpy(&answerdata->sentence[count1],sym);
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
//						printf("%s\n",answer);
						count1 ++;
//						loop = OFF;
					}
				}else if((commdata->buffer[0] == START_TAG1) && (commdata->buffer[1] == KIS_START_TAG1)){	// $( Ŏn܂Ă
				// $()
					tagf = ')';
					strcpy(tag_tmp,answerdata->sentence);
					if((niscode_ret = (s20_data*)malloc(sizeof(s20_data))) == NULL){
						printf("*** malloc error! ***");
					}else{
						s20_data_clear(niscode_ret);
						printf("buffer:%s\n",commdata->buffer);
						make_kiscode(niscode_ret,commdata->buffer,nest,commdata);
						shiori_answer_encode(tag_tmp,*niscode_ret,commdata->code);
						printf("** buffer:%s\n",commdata->buffer);
						printf("make_kiscode answer:\n%s\n",tag_tmp);
						strcpy(&answerdata->sentence[count1],niscode_ret->sentence);
						count1 += strlen(niscode_ret->sentence);
					}
					free(niscode_ret);
				}else if(commdata->buffer[0] == KIS_END_TAG){
				// $()I
					if(tagf == ')'){
						printf("$()\n");
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
						tagf = OFF;
//						printf("answer_tmp:%s:\n",buffer);
					}else{
						// ʏ̔pƂďB
						printf("normal:%s:\n",sym);
						strcpy(&answerdata->sentence[count1],sym);
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
//						printf("%s\n",answer);
						count1 ++;
//						loop = OFF;
					}
				}else if((commdata->buffer[0] == START_TAG1) && (commdata->buffer[1] == CHR_START_TAG1)){	// $[ Ŏn܂Ă
				// $[]
//					logwrite0("$[]\n");
					tagf = ']';
//					strcpy(tag_tmp,answerdata->sentence);
					if((niscode_ret = (s20_data*)malloc(sizeof(s20_data))) == NULL){
						printf("*** malloc error! ***");
					}else{
						s20_data_clear(niscode_ret);
//						printf("buffer:%s\n",commdata->buffer);
						sprintf(LogTmp,"buffer:%s\n",commdata->buffer);
//						logwrite0(LogTmp);
						make_chrcode(niscode_ret,commdata->buffer,nest,commdata);
//						shiori_answer_encode(tag_tmp,*niscode_ret,commdata->code);
						printf("** buffer:%s\n",commdata->buffer);
						printf("make_chrcode answer:\n%s\n",tag_tmp);
						strcpy(&answerdata->sentence[count1],niscode_ret->sentence);
						count1 += strlen(niscode_ret->sentence);
					}
					free(niscode_ret);
					niscode_ret = NULL;								/*  */
//					strcpy(&commdata->buffer[0],&commdata->buffer[2]);
				}else if(commdata->buffer[0] == CHR_END_TAG){
				// $[]I
					if(tagf == ']'){
//						logwrite0("$[]\n");
//						sprintf(LogTmp,"answer:%s\n",&answerdata->sentence);
//						logwrite0(LogTmp);
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
						tagf = OFF;
//						printf("answer_tmp:%s:\n",buffer);
					}else{											/*  */
						// ʏ̔pƂďB
//						printf("normal:%s:\n",sym);
						strcpy(&answerdata->sentence[count1],sym);
						strcpy(&commdata->buffer[0],&commdata->buffer[1]);
//						printf("%s\n",answer);
						count1 ++;
//						loop = OFF;
					}							/*  */
				}else{
				// tagłȂʏ피p̏
//					printf("normal:%s:\n",sym);
					strcpy(&answerdata->sentence[count1],sym);
					strcpy(&commdata->buffer[0],&commdata->buffer[1]);
//					printf("%s\n",answer);
					count1 ++;
				}

			}else if(symbol_len == 2){						// 2bytȅ
				if((count1+2) < AnswerLength){
//					printf("2bytenormal:%s:\n",sym);
					strcpy(&answerdata->sentence[count1],sym);
					strcpy(&commdata->buffer[0],&commdata->buffer[2]);
					count1 += 2;
				}else{
//					printf("answer_tmp OVERFLOW!\n");
					loop = OFF;
				}
			}
			
		}while((strlen(commdata->buffer)>0) && (loop == ON));
		answerdata->sentence[count1] = '\0';
		
		taglist_free(nest);									/* TAG̋L̈ */
	}
	free(tag_tmp);
#ifdef DEBUG_PRINT
	printf("return:%s\n",answerdata->sentence);
#endif

	return;
}

//---------------------------------------------------------------------------
//	chrcodeϊ
//---------------------------------------------------------------------------
void make_chrcode(struct s20_data *answerdata,char *buffer,int nest,struct s20_data *commdata)
{
	char *pointer0;
	char *tag_tmp = NULL;
//	char *nest_answer = NULL;
	char answer[255];
	
	struct s20_data *sentence;
	struct s20_data *command_tmp;
	struct s20_data *nis_request;
	
	unsigned int hexcode;
	

	printf("*** make_chrcode ***\n");
//	logwrite0("*** make_kiscode ***\n");
//	sprintf(LogTmp,"buffer:%s:\n",buffer);
//	logwrite(LogTmp);

//	s20_data_clear(&answerdata);
	strcpy(answer,"");
	nis_request = NULL;
	sentence = NULL;
	command_tmp = NULL;

//	if( ((tag_tmp = (char*)malloc(AnswerLength))==NULL) || ((nest_answer = (char*)malloc(AnswerLength))==NULL) ){
	if((tag_tmp = (char*)malloc(AnswerLength))==NULL){
//		strcpy(answer,"malloc error.");
		strcpy(answerdata->sentence,"malloc error.");
	}else{
//		printf("make_kiscode buffer:%s\n",buffer);
		strcpy(&buffer[0],&buffer[2]);						// $[ 

		pointer0 = strstr2(buffer,CHR_END_TAG2);			// ]T
		if(pointer0 != NULL){
			memcpy(tag_tmp,buffer,pointer0 - buffer);
			tag_tmp[pointer0 - buffer] = '\0';
			strcpy(&buffer[0],pointer0);
			printf("buffer:%s:\n",buffer);
			printf("CHR code:%s:\n",tag_tmp);
			
			if((tag_tmp[0]=='0')&&(tag_tmp[1]=='x')){
				if( (tag_tmp[3]>='0') && (tag_tmp[3]<='9') ){
					hexcode = tag_tmp[3] - '0';
				}else
				if( (tag_tmp[3]>='a') && (tag_tmp[3]<='f') ){
					hexcode = tag_tmp[3] - 'a';
				}else
				if( (tag_tmp[3]>='A') && (tag_tmp[3]<='F') ){
					hexcode = tag_tmp[3] - 'A';
				}else{
					hexcode = 0xFFFF;
				}

				if( (tag_tmp[2]>='0') && (tag_tmp[2]<='9') ){
					hexcode += (tag_tmp[2] - '0') * 0x10;
				}else
				if( (tag_tmp[2]>='a') && (tag_tmp[2]<='f') ){
					hexcode += (tag_tmp[2] - 'a') * 0x10;
				}else
				if( (tag_tmp[2]>='A') && (tag_tmp[2]<='F') ){
					hexcode += (tag_tmp[2] - 'A') * 0x10;
				}else{
					hexcode = 0xFFFF;
				}
				
				printf("hexcode = %x\n",hexcode);
				printf("hexcode = %c\n",hexcode);
				
				if(hexcode != 0xFFFF){
					answerdata->sentence[0] = hexcode;
					answerdata->sentence[1] = '\0';
				}
				printf("answer:%s:\n",answerdata->sentence);
			}


//			printf("nest_answer:%s:\n",nest_answer);
				
		}else{
			// )ȂB error.
		}
	}
	free(tag_tmp);
//	free(nest_answer);
	
	return;
}

//---------------------------------------------------------------------------
//	CCXNvg
//---------------------------------------------------------------------------
void make_kiscode(struct s20_data *answerdata,char *buffer,int nest,struct s20_data *commdata)
//void make_kiscode(char *answer,char *buffer,int nest,struct s20_data *commdata)
//void make_kiscode(char *answer,char *buffer,int nest)
{
	char *pointer0;
	char *pointer1;
	char *tag_tmp = NULL;
	char *nest_answer = NULL;
	char word[255];
	char opcode[255];
	char operand[255];
//	s20_data commdata;			// SHIORI/2.0͌
	char separater1[] = S20_Separater;
//	struct s20_data answerdata;
	char answer[255];
	
	struct s20_data *sentence;
	struct s20_data *command_tmp;
	struct s20_data *nis_request;

	printf("*** make_kiscode ***\n");
//	logwrite("*** make_kiscode ***\n");
//	sprintf(LogTmp,"buffer:%s:\n",buffer);
//	logwrite(LogTmp);

//	s20_data_clear(&answerdata);
	strcpy(answer,"");
	nis_request = NULL;
	sentence = NULL;
	command_tmp = NULL;

	if( ((tag_tmp = (char*)malloc(AnswerLength))==NULL) || ((nest_answer = (char*)malloc(AnswerLength))==NULL) ){
//		strcpy(answer,"malloc error.");
		strcpy(answerdata->sentence,"malloc error.");
	}else{
//		printf("make_kiscode buffer:%s\n",buffer);
		strcpy(&buffer[0],&buffer[2]);						// $( 

		if(((sentence = (s20_data*)malloc(sizeof(s20_data))) == NULL) || ((command_tmp = (s20_data*)malloc(sizeof(s20_data))) == NULL)){
			printf("*** malloc error! ***");
		}else{
			s20_data_clear(sentence);
			s20_data_clear(command_tmp);
			strcpy(command_tmp->buffer,buffer);
			make_sentence2(sentence,command_tmp,nest+1);
			strcpy(nest_answer,sentence->sentence);
			strcat(nest_answer,command_tmp->buffer);
		}
		free(sentence);
		free(command_tmp);
//		make_sentence(tag_tmp,buffer,nest+1);
//		strcpy(nest_answer,tag_tmp);
//		strcat(nest_answer,buffer);
		strcpy(buffer,nest_answer);							// buffer = tag_tmp + buffer
//		printf("make_tagcode:OK:%s\n",buffer);

		pointer0 = strstr2(buffer,KIS_END_TAG2);			// )T
		if(pointer0 != NULL){
			memcpy(tag_tmp,buffer,pointer0 - buffer);
			tag_tmp[pointer0 - buffer] = '\0';
			strcpy(&buffer[0],pointer0);
			printf("buffer:%s:\n",buffer);
			printf("NIS code:%s:\n",tag_tmp);

			if(nest < NEST_MAX){
				getbufpword(word,tag_tmp);
				if(strcmp(word,NIS_SET) == 0){
				// set
//					printf("NIS_SET\n");
					getbufpword(opcode,tag_tmp);
					getbufpword(operand,tag_tmp);
//					printf("set code:%s:%s:%s\n",word,opcode,operand);
					if(strcmp(opcode,"talk_interval") == 0){
//						printf("talk_interval\n");
						ghost_profile.ghosttalkinterval = atoi(operand);		// talk_interval ݒ
//						printf("talk_interval = %d:\n",ghost_profile.ghosttalkinterval);
//						sprintf(LogTmp,"talk_interval = %d:\n",ghost_profile.ghosttalkinterval);
//						logwrite(LogTmp);
					}else if(strcmp(opcode,NIS_Command_To) == 0){
						strcpy(commdata->to,operand);
//						printf("Command.To:%s:\n",commdata->to);
					}
				}else if(strcmp(word,NIS_NASINO_EVENT) == 0){
//					printf("NIS_NASINO_EVENT\n");
					if((nis_request = (s20_data*)malloc(sizeof(s20_data))) == NULL){
						printf("malloc error!\n");
					}else{
						s20_data_clear(nis_request);
						getbufpword(opcode,tag_tmp);
						strcpy(nis_request->event,opcode);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference0,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference1,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference2,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference3,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference4,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference5,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference6,operand);
						getbufpword(operand,tag_tmp);
						strcpy(nis_request->reference7,operand);
					
						nis_request->code = GET_Sentence;
						nis_request->version = 22;
						strcpy(nis_request->sender,"");
						strcpy(nis_request->ghost,"");
						strcpy(nis_request->charset,"");
						strcpy(nis_request->word,"");
						strcpy(nis_request->sentence,"");
						strcpy(nis_request->type,"");
						strcpy(nis_request->id,"");
						nis_request->age = 0;
/*					
						printf("event:%s:%s:\n",nis_request->event,tag_tmp);
						printf("reference0:%s:%s:\n",nis_request->reference0,tag_tmp);
						printf("reference1:%s:%s:\n",nis_request->reference1,tag_tmp);
						printf("reference2:%s:%s:\n",nis_request->reference2,tag_tmp);
						printf("reference3:%s:%s:\n",nis_request->reference3,tag_tmp);
						printf("reference4:%s:%s:\n",nis_request->reference4,tag_tmp);
						printf("reference5:%s:%s:\n",nis_request->reference5,tag_tmp);
						printf("reference6:%s:%s:\n",nis_request->reference6,tag_tmp);
						printf("reference7:%s:%s:\n",nis_request->reference7,tag_tmp);
*/					
//						n_request(answer,nis_request);
						n_request(answerdata,nis_request);
						shiori_answer_encode(answer,*answerdata,nis_request->code);
						printf("answer:%s\n",answer);
//						pointer0 = strstr2(answer,"Sentence: ");
//						strcpy(&answer[0],pointer0+10);
//						answer[strlen(answer)-2] = '\0';
//						strcpy(answer,answerdata->sentence);
						printf("answer:%s:\n",answerdata->sentence);
					}
					free(nis_request);
				}
			}else{
			
			}

//			printf("nest_answer:%s:\n",nest_answer);
				
		}else{
			// )ȂB error.
		}
	}
	free(tag_tmp);
	free(nest_answer);
	
	return;
}

//---------------------------------------------------------------------------
void make_tagcode(char *answer,char *buffer,int nest)
{
	char *pointer0;
	char *tag_tmp = NULL;
	char *nest_answer = NULL;
	char *buffer_tmp = NULL;

	printf("-- make_tagcode --\n");
	printf("%d:%d\n",nest,NEST_MAX);
//	logwrite("-- make_tagcode --\n");
//	sprintf(LogTmp,"%d:%s\n",nest,buffer);
//	logwrite(LogTmp);

	if( (tag_tmp = (char*)malloc(AnswerLength))==NULL){
		strcpy(answer,"malloc error.");
		printf("malloc error.\n");
	}else{
		strcpy(&buffer[0],&buffer[2]);						// ${ 

		printf("GO make_sentence!\n");
//		logwrite("GO make_sentence!\n");
		make_sentence(tag_tmp,buffer,nest+1);
		printf("RETURN make_sentence!:%s\n",tag_tmp);
//		sprintf(LogTmp,"RETURN make_sentence!:%s\n",tag_tmp);
//		logwrite(LogTmp);

		if( (buffer_tmp = (char*)malloc(strlen(buffer)+1))==NULL){
			logwrite("malloc error.buffer_tmp\n");
		}else{
			strcpy(buffer_tmp,buffer);
			strcpy(buffer,tag_tmp);
			strcat(buffer,buffer_tmp);
//			strcpy(buffer,nest_answer);							// buffer = tag_tmp + buffer
			printf("make_tagcode:OK:%s\n",buffer);
		}
		free(buffer_tmp);


		if( (nest_answer = (char*)malloc(AnswerLength))==NULL){
			logwrite("malloc error.nest_answer\n");
		}else{

//			strcpy(nest_answer,tag_tmp);
//			strcat(nest_answer,buffer);
//			strcpy(buffer,nest_answer);							// buffer = tag_tmp + buffer
//			printf("make_tagcode:OK:%s\n",buffer);
			pointer0 = strstr2(buffer,END_TAG2);				// }T
			if(pointer0 != NULL){
				memcpy(tag_tmp,buffer,pointer0 - buffer);
				tag_tmp[pointer0 - buffer] = '\0';
				strcpy(&buffer[0],pointer0);
//				printf("tag_tmp:%s:\n",tag_tmp);

				if(nest < NEST_MAX){
//					logwrite("GO n_getword!\n");
					n_getword(nest_answer,tag_tmp,nest+1);
//					logwrite("RETURN n_getword!\n");
//					printf("nest_answer:%s\n",nest_answer);
////					strcat(answer,answer_tmp);
					strcat(answer,nest_answer);
//					printf("answer:%s:\n",answer);
////				printf("tag get! tag_tmp: %s :nest_answer: %s :make_answer: %s\n",tag_tmp,nest_answer,make_answer);
					if((tag_tmp[0]<'0') || (tag_tmp[0]>'9')){		// OQƗp̐l^Oł͂Ȃ
//						sprintf(LogTmp,"tag get! : %s : %s\n",tag_tmp,nest_answer);
//						logwrite(LogTmp);
						taglist_set(nest_answer,nest);
					}
				}else{
					// ł
//					strcat(answer,answer_tmp);
					strcat(answer,tag_tmp);			// R[h
					strcat(answer,"Ȃ");			// R[h
				}
//				printf("nest_answer:%s:\n",nest_answer);
//				sprintf(LogTmp,"nest_answer:%s:\n",nest_answer);
//				logwrite(LogTmp);
					
			}else{
				// )ȂB error.
			}
		}
	}
	free(tag_tmp);
	free(nest_answer);
	
//	logwrite("-- make_tagcode END --\n");
	
	return;
}

//---------------------------------------------------------------------------
void make_tagcode_old(char *answer,char *buffer,int nest)
{
	char *pointer0;
	char *tag_tmp = NULL;
	char *nest_answer = NULL;

	printf("-- make_tagcode --\n");
	printf("%d:%d\n",nest,NEST_MAX);
	logwrite("-- make_tagcode --\n");
	sprintf(LogTmp,"%d:%s\n",nest,buffer);
	logwrite(LogTmp);

	if( ((tag_tmp = (char*)malloc(AnswerLength))==NULL) || ((nest_answer = (char*)malloc(AnswerLength))==NULL) ){
		strcpy(answer,"malloc error.");
	}else{
		strcpy(&buffer[0],&buffer[2]);						// ${ 

		logwrite("GO make_sentence!\n");
		make_sentence(tag_tmp,buffer,nest+1);
		strcpy(nest_answer,tag_tmp);
		strcat(nest_answer,buffer);
		strcpy(buffer,nest_answer);							// buffer = tag_tmp + buffer
		printf("make_tagcode:OK:%s\n",buffer);
		sprintf(LogTmp,"make_tagcode:OK:%s\n",buffer);
		logwrite(LogTmp);

		pointer0 = strstr2(buffer,END_TAG2);				// }T
		if(pointer0 != NULL){
			memcpy(tag_tmp,buffer,pointer0 - buffer);
			tag_tmp[pointer0 - buffer] = '\0';
			strcpy(&buffer[0],pointer0);
			printf("tag_tmp:%s:\n",tag_tmp);
			sprintf(LogTmp,"tag_tmp:%s:\n",tag_tmp);
			logwrite(LogTmp);

			if(nest < NEST_MAX){
				n_getword(nest_answer,tag_tmp,nest+1);
				printf("nest_answer:%s\n",nest_answer);
//				strcat(answer,answer_tmp);
				strcat(answer,nest_answer);
				printf("answer:%s:\n",answer);
				sprintf(LogTmp,"answer:%s:\n",answer);
				logwrite(LogTmp);
////			printf("tag get! tag_tmp: %s :nest_answer: %s :make_answer: %s\n",tag_tmp,nest_answer,make_answer);
				if((tag_tmp[0]<'0') || (tag_tmp[0]>'9')){		// OQƗp̐l^Oł͂Ȃ
//					sprintf(LogTmp,"tag get! : %s : %s\n",tag_tmp,nest_answer);
//					logwrite(LogTmp);
					taglist_set(nest_answer,nest);
				}
			}else{
				// ł
//				strcat(answer,answer_tmp);
				strcat(answer,tag_tmp);			// R[h
				strcat(answer,"Ȃ");			// R[h
			}
			printf("nest_answer:%s:\n",nest_answer);
			sprintf(LogTmp,"nest_answer:%s:\n",nest_answer);
			logwrite(LogTmp);
				
		}else{
			// )ȂB error.
		}
	}
	free(tag_tmp);
	free(nest_answer);
	
	logwrite("-- make_tagcode END --\n");
	
	return;
}

//---------------------------------------------------------------------------
//		^ꂽ͂̃^OB
//---------------------------------------------------------------------------
void make_sentence_old(char* answer,char* buffer,int nest)
{
//	int nest = 0;

	int count1;
	int count2;
//	char answer_tmp[AnswerLength];
//	char tag_tmp[AnswerLength];
//	char make_answer[AnswerLength];
//	char nest_answer[AnswerLength];
	char sym;
	char sym2;
	
	char *answer_tmp;
	char *tag_tmp;
	char *make_answer;
	char *nest_answer;

	if((answer_tmp = (char*)malloc(AnswerLength))==NULL){
		strcpy(answer,"malloc error.");
		return;
	}
	if((tag_tmp = (char*)malloc(AnswerLength))==NULL){
		strcpy(answer,"malloc error.");
		return;
	}
	if((make_answer = (char*)malloc(AnswerLength))==NULL){
		strcpy(answer,"malloc error.");
		return;
	}
	if((nest_answer = (char*)malloc(AnswerLength))==NULL){
		strcpy(answer,"malloc error.");
		return;
	}



		strcpy(answer_tmp,buffer);
	
//		printf("answer : %d : %s\n",nest,answer_tmp);
		count1=0;
		do{
			sym = getsym(answer_tmp);
			/* ^OEo */
			if(sym == START_TAG1){
				sym = getsym(answer_tmp);
				sym2 = sym;
				if(sym == START_TAG2){
					count2=0;
					do{
						sym = getsym(answer_tmp);
						if((sym != END_TAG) && (sym != '\0')){
							tag_tmp[count2] = sym;
							count2++;
						}else{
							tag_tmp[count2] = '\0';
							count2++;
						}
					}while((sym != END_TAG) && (sym != '\0'));
					printf("tag:%s\n",tag_tmp);
					/* ^Ou */
					if(nest < NEST_MAX){
						n_getword(nest_answer,tag_tmp,nest+1);
						printf("nest_answer:%s\n",nest_answer);
						strcpy(&make_answer[count1],nest_answer);
						count1 = count1 + strlen(nest_answer);
////						printf("tag get! tag_tmp: %s :nest_answer: %s :make_answer: %s\n",tag_tmp,nest_answer,make_answer);
//						if(Debug == ON){
//							sprintf(LogTmp,"tag get! : %s : %s\n",tag_tmp,nest_answer);
//							logwrite(LogTmp);
//						}
//						if((nest == 0) && 
						if((tag_tmp[0]<'0') || (tag_tmp[0]>'9')){		// OQƗp̐l^Oł
//							sprintf(LogTmp,"tag get! : %s : %s\n",tag_tmp,nest_answer);
//							logwrite(LogTmp);
							taglist_set(nest_answer,nest);
						}
					}else{
						/* ł */
						strcpy(&make_answer[count1],tag_tmp);			/* R[h */
					}
				}else{
					make_answer[count1]=sym2;
					count1++;
					make_answer[count1]=sym;
					count1++;
				}
			}else{
				make_answer[count1]=sym;
				count1++;
			}
		
		}while(strlen(answer_tmp)>0);
		make_answer[count1] = '\0';
		taglist_free(nest);									/* TAG̋L̈ */
		
//		if(Debug == ON){
//			sprintf(LogTmp,"make_answer! : %s : %s :: %s : %s\n",answer,keycode,tag_tmp,nest_answer);
//			logwrite(LogTmp);
//		}
	
	strcpy(answer,make_answer);


	free(answer_tmp);
	free(tag_tmp);
	free(make_answer);
	free(nest_answer);

	return;

}

//---------------------------------------------------------------------------
//		descript.txt疼Oǂݍ
//---------------------------------------------------------------------------
int n_setupnametable(char* sakuraname,char* keroname, char* friendname)
{
	FILE *fp;
	char filename[DataLength];
	char data_buffer[DicBufferLength];		/* t@C̓ǂݏodata */
	char tag[DataLength];				/* ؂odata */
	char word[DataLength];				/* ؂odata */

	int loop;
	
	
	sprintf(filename,"%s%s",DataPath,DESCRIPT_FILENAME);
	printf("descript filename : %s\n",filename);
	sprintf(LogTmp,"descript filename : %s\n",filename);
	logwrite(LogTmp);
	
	strcpy(sakuraname,SAKURA_DEFNAME);
	strcpy(keroname,KERO_DEFNAME);
	strcpy(friendname,FRIEND_DEFNAME);

//	return(0);
	
	// Ŏ擾̂߁B SHIORI/2.0ςق悳B
	
	if((fp=fopen(filename,"rt"))==NULL){
		/* descript.txt don't open!! */
		printf("descript.txt don't open!!\n");
		logwrite("descript.txt don't open!!\n");
		return(FALSE);
	}else{
		loop = ON;
		do{
			if( fgets(data_buffer,DicBufferLength,fp) == NULL){
//				printf("data_buffer 0: %s\n",data_buffer);
				/* ǂݏoI */
				loop = OFF;
			}else{
//				sprintf(LogTmp,"data_buffer : %s\n",data_buffer);
//				logwrite(LogTmp);
				getbufword(tag,data_buffer);
//				printf("tag:%s:",tag);
//				getsym(data_buffer);
				getbufword(word,data_buffer);
//				printf("woed:%s:\n",word);
				if(strcmp(tag,SAKURA_NAMETAG) == 0){			// ̖O() request_notify()ɏ
					strcpy(ghost_profile.sakuraname,word);
				}else if(strcmp(tag,SAKURA_NAMETAG2) == 0){		// ̖O()
					strcpy(ghost_profile.sakuraname2,word);
				}else if(strcmp(tag,KERO_NAMETAG) == 0){		// ɂイ̖O
					strcpy(ghost_profile.keroname,word);
				}else if(strcmp(tag,FRIEND_NAMETAG) == 0){		// FB̖O
					strcpy(ghost_profile.friendname,word);
				}
			}
		}while(loop == ON);
		fclose(fp);
	}
	
	return(0);
}

//---------------------------------------------------------------------------
//		Œ^Oϊ
//---------------------------------------------------------------------------
int tagchange(char *answer,char *tag,int nest)
{
	int ret;

//	logwrite("tagchange\n");
//	printf("tagchange\n");

	/* ܂藘Ȃ肩ȂBȏ㐔ȂA[v܂킹BĂ䂤dlǂ߁B */
	if(strcmp(tag,SAKURA_DEFNAME) == 0){					// IɎ
		strcpy(answer,ghost_profile.sakuraname);
//		printf("sakuraname OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"sender") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.sender);
//		printf("sender OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference0") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference0);
//		printf("reference0 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference1") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference1);
//		printf("reference1 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference2") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference2);
//		printf("reference2 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference3") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference3);
//		printf("reference3 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference4") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference4);
//		printf("reference4 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference5") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference5);
//		printf("reference5 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference6") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference6);
//		printf("reference6 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,"reference7") == 0){				// Œtagϊ
		strcpy(answer,communication_memory.reference7);
//		printf("reference7 OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,MYNAME) == 0){						// ؘaŒtagϊ
//		strcpy(answer,ghost_profile.sakuraname);
		strcpy(answer,SakuraName);
//		printf("sakuraname OK:%s\n",answer);
		ret = OK;
	}else if(strcmp(tag,UNYUNAME) == 0){					// ؘaŒtagϊ
//		strcpy(answer,ghost_profile.keroname);
		strcpy(answer,KeroName);
//		printf("unyuname OK:%s\n",answer);
		ret = OK;
	}else if((tag[0]>='0') && (tag[0]<='9')){				/* tag */
//		printf("tagprint: %s\n",tag);
		if(taglist_get(answer,atoi(tag),nest) == OK){
//			printf("number tag get! : %s\n",answer);
//			sprintf(LogTmp,"number tag get! : %s\n",answer);
//			logwrite(LogTmp);
//			printf("tag OK\n");
			ret = OK;
		}else{
//			printf("NG\n");
			ret = NG;
		}
	}else{
//		printf("NG\n");
		ret = NG;
	}
	
//	sprintf(LogTmp,"tagchange : %d\n",ret);
//	logwrite(LogTmp);
//	if(ret == OK) printf("tagchange_answer! ans: %s tag: %s\n",answer,tag);
//	sprintf(LogTmp,"tagchange_answer! : %s : %s : %d\n",answer,tag,ret);
//	logwrite(LogTmp);
	
	return(ret);
}

//---------------------------------------------------------------------------
//		TAG̋L
//---------------------------------------------------------------------------
int taglist_set(char *word,int nest)
{
	int wordlen;
	int ret;
	
//	printf("-- taglist_set --\n");
//	printf("TagListPoint:%d\n",TagListPoint);
	
	wordlen = strlen(word);
//	printf("wordlen : %d\n",wordlen);
	if((TagListPoint < TAGLIST_MAX) && (wordlen != 0)){
		TagList[TagListPoint].data = (char*)malloc(wordlen+1);
		if(TagList[TagListPoint].data != NULL){
			strcpy(TagList[TagListPoint].data,word);
//			strcpy(TagList[TagListPoint],word);
//			memcpy(TagList[TagListPoint],word,wordlen+1);
			TagList[TagListPoint].nest = nest;
//			printf("number tag set! TagList[TagListPoint-1].data:%s:TagList[TagListPoint].nest:%d:nest:%d:TagListPoint-1:%d :wordlen:%d:word:%s\n",TagList[TagListPoint-1].data,TagList[TagListPoint].nest,nest,TagListPoint-1,wordlen,word);
//			printf("taglist_set : %d : %d : %s : %s : %d\n",TagListPoint,wordlen,word,TagList[TagListPoint].data,TagList[TagListPoint].nest);
			sprintf(LogTmp,"taglist_set : %d : %d : %s : %s : %d\n",TagListPoint,wordlen,word,TagList[TagListPoint].data,TagList[TagListPoint].nest);
			logwrite(LogTmp);
			TagListPoint++;
			ret = OK;
		}else{
			logwrite("taglist_set malloc_error\n");
		}
	}else{
		ret = NG;
	}
//	printf("TagListPoint:%d\n",TagListPoint);
//	printf("taglist_set end.\n");
	return(ret);
}

//---------------------------------------------------------------------------
//		TAG̎o
//---------------------------------------------------------------------------
int taglist_get(char *word,int num,int nest)
{
	int ret = NG;
	int count1;
	int loop = ON;
	
//	for(count1=0;count1<TagListPoint;count1++){
//		printf("taglist : %s : %d :nest %d : num %d\n",TagList[count1].data,TagList[count1].nest,nest,num);
//	}
	
	count1=0;
	while( ((count1 + num) < TagListPoint) && (loop == ON) ){
//		printf("taglist_get : %s : %d :nest %d : num %d:count%d\n",TagList[count1].data,TagList[count1].nest,nest,num,count1);
//		printf("taglist_get : %s : %d :nest %d : num %d\n",TagList[count1 + num].data,TagList[count1 + num].nest,nest,num);
		if(TagList[count1].nest == nest - 1){
//			printf("taglist_get TagList[count1 + num].data: %s :TagList[count1 + num].nest: %d :nest %d : num %d\n",TagList[count1 + num].data,TagList[count1 + num].nest,nest,num);
			strcpy(word,TagList[count1 + num].data);
			loop = OFF;
			ret = OK;
//			printf("taglist_get_return : %d\n",ret);
		}
		count1++;
	}
	

	return(ret);
}

//---------------------------------------------------------------------------
//		TAG̋L̈
//---------------------------------------------------------------------------
int taglist_free(int nest)
{
	unsigned int loop;
	
	if(TagListPoint > 0){
		loop = ON;
	}else{
		loop = OFF;
	}

//	printf("taglist_free TagListPoint0 : %d : nest %d : %s : %d\n",TagListPoint-1,nest,TagList[TagListPoint-1].data,TagList[TagListPoint-1].nest);
	while((TagList[TagListPoint-1].nest == nest) && (loop == ON)){
		if(TagList[TagListPoint-1].nest == nest){
//			printf("FREE!! %d : %s\n",TagListPoint-1,TagList[TagListPoint-1].data);
			free(TagList[TagListPoint-1].data);
			TagList[TagListPoint-1].data = NULL;
			if(TagListPoint-1 == 0){
				loop = OFF;
			}
			TagListPoint--;
		}
	}

	return(0);
}

//---------------------------------------------------------------------------
//		͂Ɋ܂܂鎫̒PoB
//---------------------------------------------------------------------------
int n_getmatchword(char *answer,char *buffer)
{
	dic_readdata dicreaddata;
	char word[WordLength];
	char key[DataLength];

	char tmp_word[WordLength];
	char tmp_key[WordLength];
	int pointer;
	int count1;
	int key_num;

//	printf("n_getmatchword start:%s:\n",buffer);
	
	strcpy(answer,"");

	for(count1=0;count1<DicWordCount;count1++){
		get_dicword(&dicreaddata,count1);
//		printf("%d:%d:%s:%s\n",DicWordCount,count1,buffer,dicreaddata.word);
		if(chkmachword(buffer,dicreaddata,&pointer) == OK){
			/* Pꔭ */
			printf("matchword : %s:%s:%s\n",&buffer[pointer],dicreaddata.word,dicreaddata.key);
			strcpy(word,dicreaddata.word);

			/* key=compatible-* o */
			if(check_compatiblecode(dicreaddata.key,key) != NG){
				printf("mach_dicword_end : word:%s : key:%s\n",word,key);
				strcat(answer,s5wordmake(word,key));
//				printf("key : %s:\n",key);
			}else{
			/* key=compatible-* ł͂Ȃ */
				printf("compatible-T\n");
				if(get_sakuratag(key,dicreaddata,0) != NG){
					/* ċAĒTČ */
					printf("mach_dicword_end : word:%s : key:%s\n",word,key);
					if(SHIORI_VERSION == "SHIORI/1.1"){
						strcat(answer,s5wordmake(word,key));
					}else{
						printf("SHIORI/2.0 make answer.\n");
						strcpy(tmp_word,word);
						tmp_word[strlen(word)] = 0x01;
						tmp_word[strlen(word)+1] = '\0';
						memcpy(tmp_key,&key[COMPATIBLE_CODELEN],strlen(key)-COMPATIBLE_CODELEN);
						tmp_key[strlen(key)-COMPATIBLE_CODELEN] = 0x02;
						tmp_key[strlen(key)-COMPATIBLE_CODELEN+1] = '\0';
						strcat(answer,tmp_word);
						strcat(answer,tmp_key);
					}
				}else{
					/* ŏII compatible-* ^OȂPɂĂ͕ԓȂB */
//					printf("mach_dicword_end : word:%s : key:%s\n",word,key);
//					strcat(answer,s5wordmake(word,key));
				}
			}
			
		}
	}
	
//	sprintf(LogTmp,"");
//	logwrite(LogTmp);

	return(0);
}

//---------------------------------------------------------------------------
//		System.5 dl?̕쐬B
//		[1]\ms[CR+LF] Ă
//---------------------------------------------------------------------------
char *s5wordmake(char *word,char *key)
{
	char return_word[WordLength];
	char *ret;
	int word_len;
	int key_len;
	
	int count;
	
	char pause = 0x01;
	char crlf[3] = { 0x0d , 0x0a , '\0' };		// CR LF
	
	word_len = strlen(word);
	key_len = strlen(key);
	
	memcpy(return_word,word,word_len);
	return_word[word_len] = pause;
	return_word[word_len+1] = '\\';
	memcpy(&return_word[word_len+2],key,key_len);
	memcpy(&return_word[word_len+2+key_len],crlf,3);
	
//	for(count = 0;count < word_len+2+key_len+3;count++){
//		printf("return_word : %x:\n",return_word[count]);
//	}
	
//	printf("return_word : %s:\n",return_word);
	
	ret = return_word;
	return(ret);
}

//---------------------------------------------------------------------------
//		keySAKURA^Oɋtϊ
//---------------------------------------------------------------------------
int get_sakuratag(char *key,struct dic_readdata dicreaddata,int nest)
{
	int ret = NG;
	char tmp_word[WordLength];			/* mallocŊmۂׂ */
	int key_num;
	int count;
	int loop;

	tmp_word[0] = START_TAG1;
	tmp_word[1] = START_TAG2;
	strcpy(&tmp_word[2],dicreaddata.key);
	tmp_word[strlen(dicreaddata.key)+2] = END_TAG;
	tmp_word[strlen(dicreaddata.key)+3] = '\0';

	count = 0;
	loop = ON;
	if(nest < NEST_MAX){
		do{
			key_num = mach_dicword(tmp_word,&dicreaddata,count);
			printf("key_num : %d :%s: %d\n",nest,tmp_word,key_num);
			if(key_num != 0){
				/* key=compatible-* o */
				printf("mach_dicword1 : %s : %s : %s\n",tmp_word,dicreaddata.word,dicreaddata.key);
				if(check_compatiblecode(dicreaddata.key,key) != NG){
				
					printf("key : %s:\n",key);
					ret = OK;
					loop = OFF;
				}else{
					if(get_sakuratag(key,dicreaddata,nest+1)){		/* Ȃ̂ōċAB */
						ret = OK;
					}
//					printf("no mach_dicword0 : %s:%s\n",tmp_word,key);
				}
			}else{
				/* Ȃꍇ ms Ƃ */		/* Ƃ̂člĐقBnestgĂȂBœKBςoOĂB */
				strcpy(key,"ms");
//				ret = NG;
			}
			count++;
		}while((count < key_num) && (loop == ON));
	 }
//	printf("key : %s:\n",key);

	return(ret);
}

//---------------------------------------------------------------------------
//		COMPATIBLE_CODẼ`FbN
//
//		*dickey		IN		ׂkey
//		*key		OUT		oSAKURA TAG
//		return		OUT		OK:SAKURA TAG	NG:݂ˁ[
//---------------------------------------------------------------------------
int check_compatiblecode(char *dickey,char *key)
{
	int ret = NG;
	char compatible_w[COMPATIBLE_CODELEN+1];

//	if(strlen(dicreaddata.key) > 11){
	if(strlen(dickey) > COMPATIBLE_CODELEN){
		memcpy(compatible_w,dickey,COMPATIBLE_CODELEN);
		compatible_w[COMPATIBLE_CODELEN] = '\0';
//		printf("compatible  : %d : %s:\n",strlen(compatible_w),compatible_w);
		
		if(strcmp(compatible_w,COMPATIBLE_CODE) == 0){
			/* COMPATIBLE_CODEo keyo */
			strcpy(key,dickey);
//			memcpy(key,&dickey[COMPATIBLE_CODELEN],strlen(dickey)-COMPATIBLE_CODELEN);
//			key[strlen(dickey)-COMPATIBLE_CODELEN] = '\0';
//			printf("key : %s:\n",key);
			ret = OK;
		}
	}

	return(ret);
}
//---------------------------------------------------------------------------
//		w肳ꂽPƈvTB
//		ɕ̓PꂪƁAɃqbĝoȂBdlIIςqbgԂnumԖڂo悤ɂƂȂƉȂB
//
//		*word			IN		TP
//		*dicreaddata	OUT		P
//		num				IN		vPꂪ񂠂ꍇAnumԖڂoBnumԖڂoȂB
//		ret				OUT		vP̐
//---------------------------------------------------------------------------
int mach_dicword(char *word,struct dic_readdata *dicreaddata,int num)
{
	int ret = 0;
	int count1 = 0;
	int loop = ON;
	
	dic_readdata tmp_dicreaddata;
	
	do{
		get_dicword(&tmp_dicreaddata,count1);
		if(strcmp(word,tmp_dicreaddata.word) == 0){
//			printf("mach_dicword0 : %s : %s\n",tmp_dicreaddata.word,tmp_dicreaddata.key);
			if(ret == num){
				strcpy(dicreaddata->word,tmp_dicreaddata.word);
				strcpy(dicreaddata->key,tmp_dicreaddata.key);
//				loop = OFF;
			}
			ret++;
		}
		count1++;
	}while((loop == ON) && (count1<DicWordCount));
	
//	printf("num:%d\n",ret);
	
	return(ret);
}


//---------------------------------------------------------------------------
//		͂ɒPꂪ܂܂Ă邩𒲂ׂB
//---------------------------------------------------------------------------
int chkmachword(char *buffer,struct dic_readdata dicreaddata,int *pointer)
{
	int ret;
	char wordtemp[WordLength];			/* mallocŊmۂׂ */
	int count1;
	int temp1,temp2;
	
	temp1 = strlen(buffer);
	temp2 = strlen(dicreaddata.word);
	
	ret = NG;
//	printf("wordlen : %d : %d : %d : %s : %s\n",temp1,temp2,(temp1-temp2),buffer,dicreaddata.word);
	if((temp1-temp2) >= 0){
		for(count1=0;count1 <= (temp1-temp2);count1++){
			memcpy(wordtemp,&buffer[count1],temp2);
			wordtemp[temp2] = '\0';
//			printf("wordtemp : %s\n",wordtemp);
			if(strcmp(wordtemp,dicreaddata.word) == 0){
				*pointer = count1;
				ret = OK;
//				printf("word : %s : %d : %s\n",wordtemp,count1,&buffer[*pointer]);
			}
		}
	}
	
	return(ret);
}


//---------------------------------------------------------------------------
//		System.5dlɊÂAĂl^ɕ͂
//
//		*answer		OUT		쐬
//		*buffer		IN		͂ꂽSystem.5
//---------------------------------------------------------------------------
void n_getaistringfromtargetword(char *answer,char *buffer)
{
	char answer_tmp[AnswerLength];
	char answer_tmp2[AnswerLength];
	char key[WordLength];
	char word[WordLength];
	char word2[WordLength];
	dic_readdata dicreaddata;
	dic_readdata sentence;

	char answer_tmp3[AnswerLength];
	
	char *point;
	int temp;
	int loop;
	int count1;
	int word_count;
	int num;
	
	n_getmatchword(answer_tmp,buffer);
	printf("n_getmatchword end:%s:\n",answer_tmp);
	sprintf(LogTmp,"n_getmatchword:%s:\n",answer_tmp);
	logwrite(LogTmp);
	
	if(strlen(answer_tmp) != 0){
		s5worddecode(word,answer_tmp);			/* Po */
		printf("s5word:%s:\n",word);
		sprintf(LogTmp,"s5word:%s:\n",word);
		logwrite(LogTmp);
	
		mach_dicword(word,&dicreaddata,0);	/* Pƈv鎫f[^擾BP͈ƂOƂ */
		get_sakuratag(key,dicreaddata,0);	/* ̃^O^Oɕϊ */
	
		printf("machword_ai:%s:key:%s:%s:\n",dicreaddata.word,dicreaddata.key,key);
		sprintf(LogTmp,"machword:%s:key:%s:%s:\n",dicreaddata.word,dicreaddata.key,key);
		logwrite(LogTmp);
		/* key̎ނɂāA񓚂̃p^[I */
	
		count1 = 0;
		do{
			num = get_tagword(answer_tmp,"sentence-toieba");	// pR[hgp
			printf("%d:%s\n",num,answer_tmp);
			if(num != 0){
				strcpy(answer_tmp2,answer_tmp);
				gettagword(word2,answer_tmp2);
				printf("tagword:%s\n",word2);
				
				strcpy(&word2[0],&word2[2]);					// ^O̒g肾
				word2[strlen(word2)-1] = '\0';
				printf("tagword:%s:%s\n",word2,dicreaddata.key);
				sprintf(LogTmp,"tagword:%s:%s\n",word2,dicreaddata.key);
				logwrite(LogTmp);
				
				if(checktag2tag(word2,dicreaddata.key,0) == OK){
					printf("Tag OK!\n");
					// 񓚍쐬
					
					strcpy(answer_tmp2,answer_tmp);
//					printf("%s\n",answer_tmp2);
					point = strstr(answer_tmp2,START_TAG0);
					temp = point - answer_tmp2;
					memcpy(answer_tmp3,answer_tmp,temp);
					answer_tmp3[temp] = '\0';
//					printf("answer :%s:\n",answer_tmp3);
					strcat(answer_tmp3,dicreaddata.word);
//					printf("answer :%s:\n",answer_tmp3);
					point = strstr(answer_tmp2,END_TAG0);
					strcat(answer_tmp3,point+strlen(END_TAG0));
//					printf("answer :%s:\n",answer_tmp3);
					strcpy(answer_tmp,answer_tmp3);
					
					loop = OFF;
				}else{
					printf("Tag NG!\n");

					num = get_tagword(answer_tmp,"sentence");	// ėpR[hgp
					printf("get_tagword %d:%s\n",num,answer_tmp);
					sprintf(LogTmp,"word:%s:key:%s:%s:\n",dicreaddata.word,dicreaddata.key,key);
					logwrite(LogTmp);
					if(num != 0){
						if(strstr(answer_tmp,dicreaddata.key) != NULL){			/* b菈uB^ÕNɂĂ͍lȂ */
							printf("Tag OK!\n");
							strcpy(Com_word.word,dicreaddata.word);				/* gƂɂ͕ύXKvBp֐pӂׂ */
							strcpy(Com_word.key,dicreaddata.key);
							loop = OFF;
						}else{
							printf("Tag NG!\n");
							strcpy(Com_word.word,"");				/* gƂɂ͕ύXKvBp֐pӂׂ */
							strcpy(Com_word.key,"");
							loop = ON;
						}
					}
				}
			}else{
				n_getword(answer_tmp,"sentence",0);		/* b菈u */
			}
	
			count1++;
		}while((loop == ON) && (count1 < num));
	}else{
		n_getword(answer_tmp,"sentence",0);		/* b菈u */
	}
		
	sprintf(LogTmp,"make_sentence:%s:\n",answer_tmp);
	logwrite(LogTmp);
	make_sentence(answer,answer_tmp,0);
	
	
	return;
}

//---------------------------------------------------------------------------
//		̃^O̊Ԃ̊֌W`FbNB^OP̓^OQɕϊ\ׂ
//
//		*tag1		IN		^OP@^Oc[̍ɋ߂
//		*tag2		IN		^OQ@^Oc[̗t̕
//		nest		IN		ċA
//		ret			OUT		
//---------------------------------------------------------------------------
int checktag2tag(char *tag1,char *tag2,int nest)
{
	int ret = NG;
	char *tmp_word;
	int key_num;
	int count;
	int loop;
	
	int tag2_len;
	dic_readdata dicreaddata;

	if(strcmp(tag1,tag2) == 0){
		/* Tag1 == Tag2 */
		ret = OK;
	}else{
		tag2_len = strlen(tag2);
		if((tmp_word = (char*)malloc(tag2_len+3+1))==NULL){
			
		}else{
//			printf("checktag2tag:%d\n",nest);
			
			tmp_word[0] = START_TAG1;
			tmp_word[1] = START_TAG2;
			strcpy(&tmp_word[2],tag2);
			tmp_word[tag2_len+2] = END_TAG;
			tmp_word[tag2_len+3] = '\0';
/* */	
			count = 0;
			loop = ON;
			if(nest < NEST_MAX){
				do{
					key_num = mach_dicword(tmp_word,&dicreaddata,count);
					printf("key_num : %d :%s: %d\n",nest,tmp_word,key_num);
					if(key_num != 0){
						/* ^O̊֌W𒲂ׂ */
						if(strcmp(tag1,dicreaddata.key) == 0){
//							printf("nest:%d tag1:%s tag2:%s\n",nest,tag1,dicreaddata.key);
							ret = OK;
							loop = OFF;
						}else{
							if(checktag2tag(tag1,dicreaddata.key,nest+1)){		/* Ȃ̂ōċAB */
								ret = OK;
							}
						}
					}else{
						/* Ȃ */
						ret = NG;
					}
					count++;
				}while((count < key_num) && (loop == ON));
			 }
			 free(tmp_word);
		}
	}

	return(ret);
}

//---------------------------------------------------------------------------
//		System.5 dl?͂̕āAŏ̒PoB
//		[1]\ms[CR+LF] Ăuvo
//
//		*word		OUT		͌ʂ̒P
//		*buffer		IN		͕
//---------------------------------------------------------------------------
int s5worddecode(char *word,char * buffer)
{
	int count=0;

	while(buffer[0]!= 0x01 && buffer[0]!='\0'){	/* ̋؂蕶܂ł̕؂o */
		word[count]=buffer[0];
		strcpy(&buffer[0],&buffer[1]);
		count=count+1;
	}
	word[count]='\0';

	return count;
}


//---------------------------------------------------------------------------
//		Í
//---------------------------------------------------------------------------
char *DecryptString(char *encodedstr)
{
	char decodedstr[DicBufferLength];
	char *ret;
	char word[10];
	string str;
	unsigned int i;
	
//	printf("preencode:%s::\n",encodedstr);

	memcpy(word,encodedstr,9);
	word[9] = '\0';
//	printf("word:%s\n",word);
	if(strcmp(word,"!KAWA0000")==0){
		strcpy(&encodedstr[0],&encodedstr[9]);
		
		str = DecodeBase64(encodedstr);
		for(i=0;i<str.size();i++) {
			decodedstr[i]=str[i]^0xcc;
		}
		decodedstr[i]='\0';
	}else{
		strcpy(decodedstr,encodedstr);
	}
//	printf("encode:%s::\n",decodedstr);

	ret = decodedstr;
	return(ret);
}

//---------------------------------------------------------------------------
//		LOGo
//---------------------------------------------------------------------------
int logwrite(char* logword)
{
	FILE *fp_log;
	char filename[DataLength];
	
	if(Log == ON){
		sprintf(filename,"%s%s",DataPath,TESTLOG_FILENAME);
		printf("ini filename : %s\n",filename);

		if((fp_log = fopen(filename,"at"))==NULL){
			/* nasino.ini don't open!! */
			printf("testlogfile don't open!!\n");
			return(FALSE);
		}else{
			fputs(logword,fp_log);
			fclose(fp_log);
		}
	}

	return(0);
}

//---------------------------------------------------------------------------
//		LOGo
//---------------------------------------------------------------------------
int logwrite0(char* logword)
{
	FILE *fp_log;
	char filename[DataLength];
	
//	if(Log == ON){
		sprintf(filename,"%s%s",DataPath,TESTLOG_FILENAME);
		printf("ini filename : %s\n",filename);

		if((fp_log = fopen("c:\\nasino.log","at"))==NULL){
			/* nasino.ini don't open!! */
			printf("testlogfile don't open!!\n");
			return(FALSE);
		}else{
			fputs(logword,fp_log);
			fclose(fp_log);
		}
//	}

	return(0);
}


