//----------
//
//	ȊỎȊỎł͂ȂB
//	shiori.dllC^[tFCX
//
//		Programed by Takahiro Hayashi
//
//			2001.03.29 Phase 0.1
//
//			hayasita@na.rim.or.jp
//----------

#include "shiori_dll.h"
#include "nasino.h"
#include "nasino_script.h"

//char DataPath[PathLength];						/* ghostpath */
char *DataPath;										/* ghostpath */

char SakuraName[DataLength];
char KeroName[DataLength];
char FriendName[DataLength];

extern int Debug;
extern ghost_data ghost_profile;				// GhostɊւf[^
extern char LogTmp[AnswerLength];
extern unsigned int TagListPoint;						/* |C^ */

extern char script_filename[DataLength];		/* Nasino Script filename */

extern int DicWordCount;						/* ̑vf */
extern unsigned int SentenceCount;				// sentence ̐

extern int Randomseed;
extern unsigned int sentence_randbuf[SentenceRandbuf];	// sentence̓ꕶ̘Aǂݏo`FbNpOobt@
extern unsigned int sentence_randbuf_ptr;		// Oobt@|C^

extern FILE *fp_log;
extern int Log;
//extern int Log = OFF;



//---------------------------------------------------------------------------
//		DLL EI
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	switch(reason){
		case DLL_PROCESS_ATTACH:
			/*  */
			dic_ini();
			/* ǂݍ */
//			dic_read();
			break;

		case DLL_PROCESS_DETACH:
			/* ̗̈ */
			dic_unload();
			
			
			break;
		case DLL_THREAD_ATTACH:
			break;

		case DLL_THREAD_DETACH:
			break;

		default:
			break;
	}
	return 1;
}

//---------------------------------------------------------------------------
//		DLL
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) BOOL __cdecl load(HGLOBAL h, unsigned long len)
{

extern	FILE *fp_log;

	long t;
	int count;
	int *tag_table = NULL;					// ɂΏۂ̃e[u
	S23_ghost *ghost;

	/* ghostpath擾 */
	DataPath = NULL;
	if((DataPath = (char*)malloc(len+1)) == NULL){
		logwrite("DataPath malloc error\n");
	}else{
		memcpy( DataPath,(char *)GlobalLock(h), len );
		DataPath[len] = '\0';
	}
	
//	if(len < PathLength){
//		memcpy( DataPath,(char *)GlobalLock(h), len );
//		DataPath[len] = '\0';
//		printf("load:%s\n",DataPath);
//	}else{
//		/* Ď󂯎ȂBĂǁ[悤B */
//	}
	/* path󂯓nGAJ */
	GlobalFree(h);

	/* O擾 */
	n_setupnametable(SakuraName,KeroName,FriendName);
	
	// Ԋuݒ
	ghost_profile.ghosttalkinterval = 100;
	
	// SHIORI/2.3̈m
	if((ghost_profile.ghost_pointer = (S23_ghost*)malloc(sizeof(S23_ghost))) == NULL){
//		logwrite0("ghost_profile.ghost_pointer malloc error!\n");
	}else{
//		logwrite0("ghost_profile.ghost_pointer\n");
		ghost = ghost_profile.ghost_pointer;
		ghost->ghost_name = NULL;
		ghost->next_pointer = NULL;
	}
	ghost_profile.ghost_num = 0;	// l

	/* ̗̈ */
	logwrite("dic_unload();\n");
	dic_unload();
	
	/* ǂݍ */
	logwrite("dic_read();\n");
	dic_read();

	/* ݒ */
	if(Randomseed == 0){
		srand((int)time(&t));
	}else{
		srand(Randomseed);
	}
	
	// sentence̓ꕶ̘Aǂݏo`FbNpOobt@
	for(count=0;count<SentenceRandbuf;count++){
		sentence_randbuf[count] = DicWordCount + 1;
	}
	sentence_randbuf_ptr = 0;

	// nasino script Ǎ
//	nasino_script_init();
	nasino_script_init(script_filename);
//	nasino_script_init("script.nc");
	
	// AIOtpf[^쐬
	if((tag_table = (int*)malloc(sizeof(int) * DicWordCount))==NULL){
		// malloc error.
	}else{
		SentenceCount = tagwordcount(SENTENCE_TAG,tag_table);
	}
	free(tag_table);
	
	
	return(TRUE);
}

//---------------------------------------------------------------------------
//		DLLI
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) BOOL __cdecl unload(void)
{

//	logwrite0("unload\n");
	/* ̗̈ */
	dic_unload();
	
	// SHIORI/2.3̈
//	logwrite0("SHIORI/2.3̈ 1\n");
	if(ghost_profile.ghost_pointer != NULL){
		s23ghost_free(ghost_profile.ghost_pointer);
	}
//	logwrite0("SHIORI/2.3̈ 2\n");
	free(ghost_profile.ghost_pointer);
	ghost_profile.ghost_pointer = NULL;
//	logwrite0("SHIORI/2.3̈ 3\n");

	// nasino script ̈
	nasino_script_unload();
//	logwrite0("nasino script ̈\n");

	// logfileclose
//	if(Log == ON){
//		fclose(fp_log);
//	}

	// DataPath ̉
	free(DataPath);

	return(TRUE);
}

//---------------------------------------------------------------------------
//		request
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl request(HGLOBAL h, long *len)
{
	char answer[AnswerLength];
	char buffer[AnswerLength];
	HGLOBAL ret;								// ԓ
	s20_data commdata;			// SHIORI/2.0͌
	struct s20_data answerdata;

	printf("API request\n");
//	logwrite("API request\n");

	memcpy( buffer, ((char *)GlobalLock(h)), *len );
	buffer[*len +1] = '\0';
	GlobalFree(h);

	printf("---API request :\n%s---\n",buffer);
	sprintf(LogTmp,"---API request :\n%s---\n",buffer);
	logwrite(LogTmp);
//	sprintf(LogTmp,"TagListPoint :%d\n",TagListPoint);
//	logwrite(LogTmp);

	s20_data_clear(&answerdata);
	s20decode(&commdata,buffer);
	n_request(&answerdata,&commdata);
//	n_request(answer,&commdata);
//	n_request(answer,buffer);
	shiori_answer_encode(answer,answerdata,commdata.code);

//	sprintf(LogTmp,"TagListPoint :%d\n",TagListPoint);
//	logwrite(LogTmp);
	sprintf(LogTmp,"---API request answer %d :\n%s---\n",strlen(answer),answer);
	logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	if( ret == NULL ){
		logwrite("---API request ̊mۂɎs܂B\n");
	}else{
		memcpy(ret,answer,*len);
	}
//	sprintf(LogTmp,"+++API request answer:%s---\n",ret);
//	logwrite(LogTmp);

	return(ret);
}


//---------------------------------------------------------------------------
//		DLL̃o[WԂ
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getversion(long *len)
{
	HGLOBAL version;
	*len = strlen(SHIORI_VERSION);
	
	version = GlobalAlloc(GMEM_FIXED,*len);
	memcpy(version,SHIORI_VERSION,*len);
	
	return(version);
}

//---------------------------------------------------------------------------
//		i܂\eŏIjSAKURAXNvg
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getaistringrandom(long *len)
{
	HGLOBAL ret;								// ԓ
//	static char *answer = "\hSAKURAXNvg\e";

	char answer[AnswerLength];
	char keycode[1024];

//	memcpy( answer, ((char *)GlobalLock(h))+1, *len );
//	memcpy( keycode, ((char *)GlobalLock(h))+1, *len );
//	keycode[*len] = '\0';

//	Debug = ON;
	n_getword(answer,"sentence",0);

		sprintf(LogTmp,"API getaistringrandom : %s\n",answer);
		logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);
}

//---------------------------------------------------------------------------
//		System.5dlɊÂA镶N_ɂ
//		܂\eŏIjSAKURAXNvg
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getaistringfromtargetword(HGLOBAL h, long *len)
{

	HGLOBAL ret;								// ԓ
//	static char *answer = "\hSystem.5dlɊÂA镶N_ɂSAKURAXNvg\e";
	char answer[AnswerLength];
	char buffer[DataLength];
	
	int count;

	memcpy( buffer, ((char *)GlobalLock(h)), *len );
	buffer[*len +1] = '\0';
	GlobalFree(h);

//	sprintf(LogTmp,"API getaistringfromtargetword : %s\n",buffer);
//	logwrite(LogTmp);
//	for(count=0;count<=strlen(buffer);count++){
//		sprintf(LogTmp,"API getaistringfromtargetword buffer : %x:\n",buffer[count]);
//		logwrite(LogTmp);
//	}


//	if(Debug == OFF){
//		n_getword(answer,"sentence",0);		/* b菈u */
//	}else{
//		strcpy(answer,buffer);
//		strcat(answer,"\n\\uȂ݂ɂ̕System.5dlɊÂA镶N_ɂSAKURAXNvgB\\e");
//	}

	sprintf(LogTmp,"API getaistringfromtargetword buffer :%s:\n",buffer);
	logwrite(LogTmp);
	n_getaistringfromtargetword(answer,buffer);
	sprintf(LogTmp,"API getaistringfromtargetword answer :%s:\n",answer);
	logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);
}

//---------------------------------------------------------------------------
//		u`Ɂ``v`SAKURAXNvgfЁiPj
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getdms(long *len)
{
	HGLOBAL ret;								// ԓ
	char answer[AnswerLength];
//	static char *answer = "u`Ɂ``v`SAKURAXNvgfЁiPj";

	n_getword(answer,"dms",0);

		sprintf(LogTmp,"API getdms : %s\n",answer);
		logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);

}

//---------------------------------------------------------------------------
//		PʂɑΉSAKURAXNvgfЁiPj
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getword(HGLOBAL h, long *len)
{
	HGLOBAL ret;								// ԓ
//	static char *answer = "PʂɑΉSAKURAXNvgfЁiPj";
	char answer[AnswerLength];
	char keycode[1024];

//	logwrite("API getword\n");

//	memcpy( answer, ((char *)GlobalLock(h))+1, *len );
	sprintf(keycode,"%s%s","compatible-",((char *)GlobalLock(h))+1);
//	strcpy( keycode,"compatible-");
//	memcpy( keycode, ((char *)GlobalLock(h))+1, *len );
//	keycode[strlen("compatible-") + *len +1] = '\0';
	keycode[strlen(COMPATIBLE_CODE) + *len +1] = '\0';

//	Debug = OFF;
	n_getword(answer,keycode,0);

		sprintf(LogTmp,"API getword : %s : %s\n",answer,keycode);
		logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy((char *)GlobalLock(ret),answer,*len);

	return(ret);
}

//---------------------------------------------------------------------------
//		System.5 dlɊÂ^ꂽCӂ͂̕玫Ƀqbg
//		P擾Ė{̂ɕԂ
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getmatchword(HGLOBAL h, long *len)
{

	char answer[AnswerLength];
	char buffer[1024];

	int count;


//	memcpy( keycode, ((char *)GlobalLock(h))+1, *len );
	memcpy( buffer, ((char *)GlobalLock(h)), *len );
	buffer[*len +1] = '\0';
//		sprintf(LogTmp,"API getmatchword : %s\n",buffer);
//		logwrite(LogTmp);

	GlobalFree(h);

	HGLOBAL ret;								// ԓ
//	static char *answer = "System.5 dlɊÂ^ꂽCӂ͂̕玫ɃqbgP擾Ė{̂ɕԂ";

	
	n_getmatchword(answer,buffer);
	
	sprintf(LogTmp,"API getmatchword :%s:%s:\n",buffer,answer);
	logwrite(LogTmp);
//	for(count=0;count<=strlen(answer);count++){
//		sprintf(LogTmp,"API getmatchword answer : %x:\n",answer[count]);
//		logwrite(LogTmp);
//	}

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);
}

//---------------------------------------------------------------------------
//		AIOt\pf[^
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getaistate(long *len)
{
	char dat[64];
	
	strcpy( dat, "320,240,80,120,160,400" );
	
	HGLOBAL ret = GlobalAlloc( GMEM_FIXED, strlen(dat) );
	memcpy( (char *)GlobalLock(ret), dat, strlen(dat) );
	*len = strlen(dat);
	return(ret);
}

//---------------------------------------------------------------------------
//		COMMUNICATE ֐ɑ΂ԓ
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getresponse(HGLOBAL h, long *len)
{
	char answer[AnswerLength];
	char buffer[AnswerLength];
	char wordtmp[AnswerLength];
	int temp;
//	comm11_data commdata;
	int mode;
	
	struct s20_data commdata;
	struct s20_data answerdata;
	
	
	sakura_mapdat sakura_object[SAKURA_MAPDATMAX];		//
	int sakura_objpoint = 0;							//

	memcpy( buffer, ((char *)GlobalLock(h)), *len );
	buffer[*len +1] = '\0';
	GlobalFree(h);

	HGLOBAL ret;								// ԓ
//	static char *answer = "COMMUNICATE ֐ɑ΂ԓ";

//	if(Debug == OFF){
//		n_getword(answer,"sentence",0);		// b菈u
//	}else{
//		strcpy(answer,"COMMUNICATE ֐ɑ΂ԓ\\e");
//	}
//	sprintf(LogTmp,"API getimpression : %s : %s:\n",buffer,answer);
//	logwrite(LogTmp);

	sprintf(LogTmp,"API getimpression buffer :%s:\n",buffer);
	logwrite(LogTmp);

//	n_getresponse(answer,buffer);
	strcpy(commdata.sentence,buffer);
	nasino_s20get_sentence(&answerdata,commdata);										//
	strcpy(answer,answerdata.sentence);

	sprintf(LogTmp,"API getimpression answer :%s:\n",answer);
	logwrite(LogTmp);
	
	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);
}

//---------------------------------------------------------------------------
//		COMMUNICATE ֐ɑ΂銴z
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) HGLOBAL __cdecl getimpression(HGLOBAL h, long *len)
{

	char answer[AnswerLength];
	char buffer[AnswerLength];

	memcpy( buffer, ((char *)GlobalLock(h)), *len );
	buffer[*len +1] = '\0';
	GlobalFree(h);

	HGLOBAL ret;								// ԓ
//	static char *answer = "COMMUNICATE ֐ɑ΂銴z";

	if(Debug == OFF){
		n_getword(answer,"sentence",0);		/* b菈u */
	}else{
		strcpy(answer,"COMMUNICATE ֐ɑ΂銴z\\e");
	}

	sprintf(LogTmp,"API getimpression : %s : %s:\n",buffer,answer);
	logwrite(LogTmp);

	*len=strlen(answer);
	ret=GlobalAlloc(GMEM_FIXED,*len);
	memcpy(ret,answer,*len);

	return(ret);
}


//---------------------------------------------------------------------------
//		ȉp~ꂽ炵B
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) BOOL __cdecl setupnametable(char* _sakuraname,char* _keroname, char* _friendname)
{
	return(TRUE);
}
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) BOOL __cdecl construct()
{
	return(TRUE);
}
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) BOOL __cdecl destruct()
{
	return(TRUE);
}
//---------------------------------------------------------------------------
